#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 143
#define SYMBOL_COUNT 77
#define ALIAS_COUNT 7
#define TOKEN_COUNT 48
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_disjunction_delimiter = 1,
  anon_sym_STAR = 2,
  anon_sym_QMARK = 3,
  anon_sym_PLUS = 4,
  anon_sym_LBRACE = 5,
  aux_sym_count_quantifier_token1 = 6,
  anon_sym_COMMA = 7,
  anon_sym_RBRACE = 8,
  anon_sym_QMARK_EQ = 9,
  anon_sym_QMARK_BANG = 10,
  anon_sym_QMARK_LT_EQ = 11,
  anon_sym_QMARK_LT_BANG = 12,
  anon_sym_BSLASH = 13,
  aux_sym_backreference_escape_token1 = 14,
  anon_sym_BSLASHk_LT = 15,
  anon_sym_GT = 16,
  anon_sym_QMARK_LT = 17,
  sym__name_first_char = 18,
  sym__name_additional_char = 19,
  sym_non_capturing_group_identifier = 20,
  sym_group_begin = 21,
  sym_group_end = 22,
  anon_sym_LBRACK = 23,
  anon_sym_CARET = 24,
  anon_sym_DASH = 25,
  anon_sym_RBRACK = 26,
  anon_sym_BSLASHb = 27,
  sym__set_character = 28,
  aux_sym_character_class_escape_token1 = 29,
  aux_sym_character_class_escape_token2 = 30,
  anon_sym_EQ = 31,
  sym__unicode_property = 32,
  aux_sym_identity_escape_token1 = 33,
  anon_sym_BSLASHu = 34,
  aux_sym_unicode_escape_token1 = 35,
  anon_sym_BSLASHu_LBRACE = 36,
  aux_sym_unicode_escape_token2 = 37,
  anon_sym_BSLASHx = 38,
  aux_sym_hexadecimal_escape_token1 = 39,
  anon_sym_BSLASHc = 40,
  aux_sym_control_letter_escape_token1 = 41,
  sym_special_escape = 42,
  sym_end_assertion = 43,
  sym_non_boundary_assertion = 44,
  sym_any_character = 45,
  sym__pattern_character = 46,
  sym_null_character = 47,
  sym_regex = 48,
  sym_disjunction = 49,
  sym_zero_or_more = 50,
  sym_one_or_more = 51,
  sym_optional = 52,
  sym_count_quantifier = 53,
  sym_lookahead_assertion = 54,
  sym_negative_lookahead_assertion = 55,
  sym_lookbehind_assertion = 56,
  sym_negative_lookbehind_assertion = 57,
  sym_backreference_escape = 58,
  sym_named_capturing_group = 59,
  sym_group_name = 60,
  sym_non_capturing_group = 61,
  sym_anonymous_capturing_group = 62,
  sym_character_set = 63,
  sym_character_range = 64,
  sym_set_identity_escape = 65,
  sym_character_class_escape = 66,
  sym_identity_escape = 67,
  sym_unicode_escape = 68,
  sym_hexadecimal_escape = 69,
  sym_control_letter_escape = 70,
  sym_escape_operator = 71,
  sym_start_assertion = 72,
  sym_boundary_assertion = 73,
  aux_sym_pattern_repeat1 = 74,
  aux_sym_group_name_repeat1 = 75,
  aux_sym_character_set_repeat1 = 76,
  alias_sym_count_quantifier_end = 77,
  alias_sym_lazy = 78,
  alias_sym_named_capturing_group_identifier = 79,
  alias_sym_range_delimiter = 80,
  alias_sym_set_negation = 81,
  alias_sym_unicode_property_name = 82,
  alias_sym_unicode_property_value = 83,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_disjunction_delimiter] = "disjunction_delimiter",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_PLUS] = "+",
  [anon_sym_LBRACE] = "count_quantifier_begin",
  [aux_sym_count_quantifier_token1] = "count_quantifier_token1",
  [anon_sym_COMMA] = "count_quantifier_delimiter",
  [anon_sym_RBRACE] = "}",
  [anon_sym_QMARK_EQ] = "lookahead_identifier",
  [anon_sym_QMARK_BANG] = "negative_lookahead_identifier",
  [anon_sym_QMARK_LT_EQ] = "lookbehind_identifier",
  [anon_sym_QMARK_LT_BANG] = "negative_lookbehind_identifier",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_backreference_escape_token1] = "backreference_escape_token1",
  [anon_sym_BSLASHk_LT] = "\\k<",
  [anon_sym_GT] = ">",
  [anon_sym_QMARK_LT] = "named_capturing_group_identifier",
  [sym__name_first_char] = "_name_first_char",
  [sym__name_additional_char] = "_name_additional_char",
  [sym_non_capturing_group_identifier] = "non_capturing_group_identifier",
  [sym_group_begin] = "group_begin",
  [sym_group_end] = "group_end",
  [anon_sym_LBRACK] = "set_begin",
  [anon_sym_CARET] = "^",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "set_end",
  [anon_sym_BSLASHb] = "\\b",
  [sym__set_character] = "_set_character",
  [aux_sym_character_class_escape_token1] = "character_class_escape_token1",
  [aux_sym_character_class_escape_token2] = "character_class_escape_token2",
  [anon_sym_EQ] = "=",
  [sym__unicode_property] = "_unicode_property",
  [aux_sym_identity_escape_token1] = "identity_escape_token1",
  [anon_sym_BSLASHu] = "\\u",
  [aux_sym_unicode_escape_token1] = "unicode_code",
  [anon_sym_BSLASHu_LBRACE] = "\\u{",
  [aux_sym_unicode_escape_token2] = "unicode_code",
  [anon_sym_BSLASHx] = "\\x",
  [aux_sym_hexadecimal_escape_token1] = "hexadecimal_code",
  [anon_sym_BSLASHc] = "\\c",
  [aux_sym_control_letter_escape_token1] = "control_letter_code",
  [sym_special_escape] = "special_escape",
  [sym_end_assertion] = "end_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [sym_any_character] = "any_character",
  [sym__pattern_character] = "_pattern_character",
  [sym_null_character] = "null_character",
  [sym_regex] = "regex",
  [sym_disjunction] = "disjunction",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_lookahead_assertion] = "lookahead_assertion",
  [sym_negative_lookahead_assertion] = "negative_lookahead_assertion",
  [sym_lookbehind_assertion] = "lookbehind_assertion",
  [sym_negative_lookbehind_assertion] = "negative_lookbehind_assertion",
  [sym_backreference_escape] = "backreference_escape",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_group_name] = "group_name",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_character_set] = "character_class",
  [sym_character_range] = "character_range",
  [sym_set_identity_escape] = "identity_escape",
  [sym_character_class_escape] = "character_class_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_unicode_escape] = "unicode_escape",
  [sym_hexadecimal_escape] = "hexadecimal_escape",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym_escape_operator] = "escape_operator",
  [sym_start_assertion] = "start_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [aux_sym_pattern_repeat1] = "pattern_repeat1",
  [aux_sym_group_name_repeat1] = "group_name_repeat1",
  [aux_sym_character_set_repeat1] = "character_set_repeat1",
  [alias_sym_count_quantifier_end] = "count_quantifier_end",
  [alias_sym_lazy] = "lazy",
  [alias_sym_named_capturing_group_identifier] = "named_capturing_group_identifier",
  [alias_sym_range_delimiter] = "range_delimiter",
  [alias_sym_set_negation] = "set_negation",
  [alias_sym_unicode_property_name] = "unicode_property_name",
  [alias_sym_unicode_property_value] = "unicode_property_value",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_disjunction_delimiter] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_count_quantifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_backreference_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHk_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_LT] = {
    .visible = true,
    .named = true,
  },
  [sym__name_first_char] = {
    .visible = false,
    .named = true,
  },
  [sym__name_additional_char] = {
    .visible = false,
    .named = true,
  },
  [sym_non_capturing_group_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_group_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_group_end] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHb] = {
    .visible = true,
    .named = false,
  },
  [sym__set_character] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_character_class_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym__unicode_property] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_identity_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHu] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unicode_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHu_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unicode_escape_token2] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHx] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_hexadecimal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHc] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_control_letter_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_special_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_character] = {
    .visible = false,
    .named = true,
  },
  [sym_null_character] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_character_set] = {
    .visible = true,
    .named = true,
  },
  [sym_character_range] = {
    .visible = true,
    .named = true,
  },
  [sym_set_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_hexadecimal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_group_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_count_quantifier_end] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_named_capturing_group_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_range_delimiter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_set_negation] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_value] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[17][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_special_escape,
  },
  [2] = {
    [1] = alias_sym_lazy,
  },
  [3] = {
    [1] = alias_sym_set_negation,
  },
  [4] = {
    [1] = alias_sym_unicode_property_value,
  },
  [5] = {
    [2] = alias_sym_count_quantifier_end,
  },
  [6] = {
    [1] = alias_sym_range_delimiter,
  },
  [7] = {
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [8] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
  },
  [9] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [10] = {
    [3] = alias_sym_count_quantifier_end,
  },
  [11] = {
    [2] = alias_sym_count_quantifier_end,
    [3] = alias_sym_lazy,
  },
  [12] = {
    [2] = alias_sym_named_capturing_group_identifier,
    [3] = alias_sym_named_capturing_group_identifier,
  },
  [13] = {
    [1] = alias_sym_unicode_property_name,
    [3] = alias_sym_unicode_property_value,
  },
  [14] = {
    [4] = alias_sym_count_quantifier_end,
  },
  [15] = {
    [3] = alias_sym_count_quantifier_end,
    [4] = alias_sym_lazy,
  },
  [16] = {
    [4] = alias_sym_count_quantifier_end,
    [5] = alias_sym_lazy,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (eof) ADVANCE(21);
      if (lookahead == '\n') ADVANCE(51);
      if (lookahead == '$') ADVANCE(72);
      if (lookahead == '(') ADVANCE(44);
      if (lookahead == ')') ADVANCE(45);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == ',') ADVANCE(28);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(74);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead == '0') ADVANCE(27);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(39);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(22);
      if (lookahead == '}') ADVANCE(29);
      if (lookahead == 8204 ||
          lookahead == 8205) ADVANCE(42);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(27);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(41);
      if (lookahead != 0) ADVANCE(51);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == ':') ADVANCE(43);
      if (lookahead == '<') ADVANCE(40);
      if (lookahead == '=') ADVANCE(30);
      END_STATE();
    case 2:
      if (lookahead == ',') ADVANCE(28);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead == '}') ADVANCE(29);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 8204 ||
          lookahead == 8205) ADVANCE(42);
      END_STATE();
    case 3:
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead != 0) ADVANCE(51);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead != 0) ADVANCE(51);
      END_STATE();
    case 5:
      if (lookahead == '-') ADVANCE(48);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(37);
      if (lookahead == '$' ||
          ('(' <= lookahead && lookahead <= '+') ||
          lookahead == '.' ||
          lookahead == '/' ||
          lookahead == '?' ||
          ('[' <= lookahead && lookahead <= '^') ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(56);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(70);
      END_STATE();
    case 6:
      if (lookahead == '0') ADVANCE(61);
      if (lookahead == '1') ADVANCE(62);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 7:
      if (lookahead == '<') ADVANCE(38);
      END_STATE();
    case 8:
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(41);
      END_STATE();
    case 9:
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 10:
      if (lookahead == '{') ADVANCE(53);
      END_STATE();
    case 11:
      if (lookahead == '}') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      END_STATE();
    case 19:
      if (eof) ADVANCE(21);
      if (lookahead == '$') ADVANCE(72);
      if (lookahead == '(') ADVANCE(44);
      if (lookahead == ')') ADVANCE(45);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == '.') ADVANCE(74);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(22);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(75);
      END_STATE();
    case 20:
      if (eof) ADVANCE(21);
      if (lookahead == '$') ADVANCE(72);
      if (lookahead == '(') ADVANCE(44);
      if (lookahead == ')') ADVANCE(45);
      if (lookahead == '.') ADVANCE(74);
      if (lookahead == '?') ADVANCE(1);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '|') ADVANCE(22);
      if (lookahead == '}') ADVANCE(29);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '{') ADVANCE(75);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_disjunction_delimiter);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_count_quantifier_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_QMARK_EQ);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_QMARK_BANG);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_EQ);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_BANG);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == 'B') ADVANCE(73);
      if (lookahead == 'b') ADVANCE(50);
      if (lookahead == 'c') ADVANCE(69);
      if (lookahead == 'k') ADVANCE(7);
      if (lookahead == 'u') ADVANCE(57);
      if (lookahead == 'x') ADVANCE(67);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(10);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(71);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          ('s' <= lookahead && lookahead <= 'w')) ADVANCE(52);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == 'b') ADVANCE(50);
      if (lookahead == 'c') ADVANCE(69);
      if (lookahead == 'u') ADVANCE(57);
      if (lookahead == 'x') ADVANCE(67);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(10);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(71);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          ('s' <= lookahead && lookahead <= 'w')) ADVANCE(52);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(aux_sym_backreference_escape_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_BSLASHk_LT);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_QMARK_LT);
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '=') ADVANCE(32);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym__name_first_char);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym__name_additional_char);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_non_capturing_group_identifier);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_group_begin);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_group_end);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_BSLASHb);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym__set_character);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token1);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token2);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym__unicode_property);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_identity_escape_token1);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      if (lookahead == '{') ADVANCE(59);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BSLASHu_LBRACE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (lookahead == '0') ADVANCE(61);
      if (lookahead == '1') ADVANCE(62);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (lookahead == '0') ADVANCE(66);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BSLASHx);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym_hexadecimal_escape_token1);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_BSLASHc);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym_control_letter_escape_token1);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_special_escape);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym__pattern_character);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 20, .external_lex_state = 1},
  [2] = {.lex_state = 20, .external_lex_state = 1},
  [3] = {.lex_state = 20, .external_lex_state = 1},
  [4] = {.lex_state = 20, .external_lex_state = 1},
  [5] = {.lex_state = 20, .external_lex_state = 1},
  [6] = {.lex_state = 20, .external_lex_state = 1},
  [7] = {.lex_state = 20, .external_lex_state = 1},
  [8] = {.lex_state = 20, .external_lex_state = 1},
  [9] = {.lex_state = 20, .external_lex_state = 1},
  [10] = {.lex_state = 20, .external_lex_state = 1},
  [11] = {.lex_state = 20, .external_lex_state = 1},
  [12] = {.lex_state = 20, .external_lex_state = 1},
  [13] = {.lex_state = 20, .external_lex_state = 1},
  [14] = {.lex_state = 20, .external_lex_state = 1},
  [15] = {.lex_state = 20, .external_lex_state = 1},
  [16] = {.lex_state = 20, .external_lex_state = 1},
  [17] = {.lex_state = 20, .external_lex_state = 1},
  [18] = {.lex_state = 20, .external_lex_state = 1},
  [19] = {.lex_state = 20, .external_lex_state = 1},
  [20] = {.lex_state = 19, .external_lex_state = 1},
  [21] = {.lex_state = 19, .external_lex_state = 1},
  [22] = {.lex_state = 19, .external_lex_state = 1},
  [23] = {.lex_state = 19, .external_lex_state = 1},
  [24] = {.lex_state = 19, .external_lex_state = 1},
  [25] = {.lex_state = 19, .external_lex_state = 1},
  [26] = {.lex_state = 19, .external_lex_state = 1},
  [27] = {.lex_state = 19, .external_lex_state = 1},
  [28] = {.lex_state = 19, .external_lex_state = 1},
  [29] = {.lex_state = 19, .external_lex_state = 1},
  [30] = {.lex_state = 19, .external_lex_state = 1},
  [31] = {.lex_state = 19, .external_lex_state = 1},
  [32] = {.lex_state = 19, .external_lex_state = 1},
  [33] = {.lex_state = 19, .external_lex_state = 1},
  [34] = {.lex_state = 19, .external_lex_state = 1},
  [35] = {.lex_state = 19, .external_lex_state = 1},
  [36] = {.lex_state = 19, .external_lex_state = 1},
  [37] = {.lex_state = 19, .external_lex_state = 1},
  [38] = {.lex_state = 19, .external_lex_state = 1},
  [39] = {.lex_state = 19, .external_lex_state = 1},
  [40] = {.lex_state = 19, .external_lex_state = 1},
  [41] = {.lex_state = 19, .external_lex_state = 1},
  [42] = {.lex_state = 19, .external_lex_state = 1},
  [43] = {.lex_state = 19, .external_lex_state = 1},
  [44] = {.lex_state = 19, .external_lex_state = 1},
  [45] = {.lex_state = 19, .external_lex_state = 1},
  [46] = {.lex_state = 19, .external_lex_state = 1},
  [47] = {.lex_state = 19, .external_lex_state = 1},
  [48] = {.lex_state = 19, .external_lex_state = 1},
  [49] = {.lex_state = 19, .external_lex_state = 1},
  [50] = {.lex_state = 19, .external_lex_state = 1},
  [51] = {.lex_state = 19, .external_lex_state = 1},
  [52] = {.lex_state = 19, .external_lex_state = 1},
  [53] = {.lex_state = 19, .external_lex_state = 1},
  [54] = {.lex_state = 19, .external_lex_state = 1},
  [55] = {.lex_state = 19, .external_lex_state = 1},
  [56] = {.lex_state = 19, .external_lex_state = 1},
  [57] = {.lex_state = 19, .external_lex_state = 1},
  [58] = {.lex_state = 3, .external_lex_state = 1},
  [59] = {.lex_state = 19, .external_lex_state = 1},
  [60] = {.lex_state = 19, .external_lex_state = 1},
  [61] = {.lex_state = 4, .external_lex_state = 1},
  [62] = {.lex_state = 4, .external_lex_state = 1},
  [63] = {.lex_state = 19, .external_lex_state = 1},
  [64] = {.lex_state = 4, .external_lex_state = 1},
  [65] = {.lex_state = 19, .external_lex_state = 1},
  [66] = {.lex_state = 4, .external_lex_state = 1},
  [67] = {.lex_state = 19, .external_lex_state = 1},
  [68] = {.lex_state = 19, .external_lex_state = 1},
  [69] = {.lex_state = 20, .external_lex_state = 1},
  [70] = {.lex_state = 20, .external_lex_state = 1},
  [71] = {.lex_state = 20, .external_lex_state = 1},
  [72] = {.lex_state = 20, .external_lex_state = 1},
  [73] = {.lex_state = 20, .external_lex_state = 1},
  [74] = {.lex_state = 20, .external_lex_state = 1},
  [75] = {.lex_state = 20, .external_lex_state = 1},
  [76] = {.lex_state = 4, .external_lex_state = 1},
  [77] = {.lex_state = 4, .external_lex_state = 1},
  [78] = {.lex_state = 4, .external_lex_state = 1},
  [79] = {.lex_state = 4, .external_lex_state = 1},
  [80] = {.lex_state = 4, .external_lex_state = 1},
  [81] = {.lex_state = 4, .external_lex_state = 1},
  [82] = {.lex_state = 4, .external_lex_state = 1},
  [83] = {.lex_state = 4, .external_lex_state = 1},
  [84] = {.lex_state = 4, .external_lex_state = 1},
  [85] = {.lex_state = 4, .external_lex_state = 1},
  [86] = {.lex_state = 4, .external_lex_state = 1},
  [87] = {.lex_state = 4, .external_lex_state = 1},
  [88] = {.lex_state = 4, .external_lex_state = 1},
  [89] = {.lex_state = 4, .external_lex_state = 1},
  [90] = {.lex_state = 4, .external_lex_state = 1},
  [91] = {.lex_state = 4, .external_lex_state = 1},
  [92] = {.lex_state = 4, .external_lex_state = 1},
  [93] = {.lex_state = 4, .external_lex_state = 1},
  [94] = {.lex_state = 4, .external_lex_state = 1},
  [95] = {.lex_state = 2},
  [96] = {.lex_state = 2},
  [97] = {.lex_state = 2},
  [98] = {.lex_state = 8},
  [99] = {.lex_state = 8},
  [100] = {.lex_state = 2},
  [101] = {.lex_state = 2},
  [102] = {.lex_state = 2},
  [103] = {.lex_state = 5},
  [104] = {.lex_state = 11},
  [105] = {.lex_state = 20},
  [106] = {.lex_state = 5},
  [107] = {.lex_state = 5},
  [108] = {.lex_state = 2},
  [109] = {.lex_state = 2},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 20},
  [112] = {.lex_state = 5},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 5},
  [115] = {.lex_state = 14},
  [116] = {.lex_state = 6},
  [117] = {.lex_state = 17},
  [118] = {.lex_state = 20},
  [119] = {.lex_state = 18},
  [120] = {.lex_state = 20},
  [121] = {.lex_state = 20},
  [122] = {.lex_state = 2},
  [123] = {.lex_state = 20},
  [124] = {.lex_state = 2},
  [125] = {.lex_state = 20},
  [126] = {.lex_state = 20},
  [127] = {.lex_state = 11},
  [128] = {.lex_state = 18},
  [129] = {.lex_state = 20},
  [130] = {.lex_state = 20},
  [131] = {.lex_state = 17},
  [132] = {.lex_state = 14},
  [133] = {.lex_state = 5},
  [134] = {.lex_state = 20},
  [135] = {.lex_state = 20},
  [136] = {.lex_state = 20},
  [137] = {.lex_state = 17},
  [138] = {.lex_state = 20},
  [139] = {.lex_state = 18},
  [140] = {.lex_state = 6},
  [141] = {.lex_state = 18},
  [142] = {.lex_state = 6},
};

enum {
  ts_external_token_null_character = 0,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_null_character] = sym_null_character,
};

static bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_null_character] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_disjunction_delimiter] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [aux_sym_count_quantifier_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_backreference_escape_token1] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym__name_first_char] = ACTIONS(1),
    [sym__name_additional_char] = ACTIONS(1),
    [sym_group_begin] = ACTIONS(1),
    [sym_group_end] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym__set_character] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [aux_sym_identity_escape_token1] = ACTIONS(1),
    [aux_sym_control_letter_escape_token1] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [sym__pattern_character] = ACTIONS(1),
    [sym_null_character] = ACTIONS(1),
  },
  [1] = {
    [sym_regex] = STATE(113),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(11),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [2] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [anon_sym_QMARK_EQ] = ACTIONS(29),
    [anon_sym_QMARK_BANG] = ACTIONS(31),
    [anon_sym_QMARK_LT_EQ] = ACTIONS(33),
    [anon_sym_QMARK_LT_BANG] = ACTIONS(35),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [anon_sym_QMARK_LT] = ACTIONS(37),
    [sym_non_capturing_group_identifier] = ACTIONS(39),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [3] = {
    [sym_disjunction] = STATE(105),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [ts_builtin_sym_end] = ACTIONS(43),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [4] = {
    [sym_disjunction] = STATE(126),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [5] = {
    [sym_disjunction] = STATE(120),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [6] = {
    [sym_disjunction] = STATE(121),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [7] = {
    [sym_disjunction] = STATE(123),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [8] = {
    [sym_disjunction] = STATE(125),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [9] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [ts_builtin_sym_end] = ACTIONS(57),
    [sym_disjunction_delimiter] = ACTIONS(57),
    [anon_sym_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASHk_LT] = ACTIONS(62),
    [sym_group_begin] = ACTIONS(65),
    [sym_group_end] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(68),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_BSLASHb] = ACTIONS(74),
    [aux_sym_character_class_escape_token1] = ACTIONS(77),
    [aux_sym_character_class_escape_token2] = ACTIONS(80),
    [anon_sym_BSLASHu] = ACTIONS(83),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(86),
    [anon_sym_BSLASHx] = ACTIONS(89),
    [anon_sym_BSLASHc] = ACTIONS(92),
    [sym_special_escape] = ACTIONS(95),
    [sym_end_assertion] = ACTIONS(95),
    [sym_non_boundary_assertion] = ACTIONS(95),
    [sym_any_character] = ACTIONS(95),
    [sym__pattern_character] = ACTIONS(95),
    [sym_null_character] = ACTIONS(95),
  },
  [10] = {
    [sym_disjunction] = STATE(118),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(98),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [11] = {
    [sym_disjunction] = STATE(110),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [ts_builtin_sym_end] = ACTIONS(100),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [12] = {
    [sym_disjunction] = STATE(129),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(102),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [13] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(104),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(104),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [14] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(8),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(106),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [15] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(10),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [16] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(7),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(110),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [17] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(6),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [18] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(5),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [19] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_character_class_escape] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(112),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(21),
    [anon_sym_BSLASHx] = ACTIONS(23),
    [anon_sym_BSLASHc] = ACTIONS(25),
    [sym_special_escape] = ACTIONS(27),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym__pattern_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(27),
  },
  [20] = {
    [sym_zero_or_more] = STATE(74),
    [sym_one_or_more] = STATE(74),
    [sym_optional] = STATE(74),
    [sym_count_quantifier] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(118),
    [sym_disjunction_delimiter] = ACTIONS(118),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(128),
    [anon_sym_BSLASHk_LT] = ACTIONS(118),
    [sym_group_begin] = ACTIONS(118),
    [sym_group_end] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_BSLASHb] = ACTIONS(118),
    [aux_sym_character_class_escape_token1] = ACTIONS(118),
    [aux_sym_character_class_escape_token2] = ACTIONS(118),
    [anon_sym_BSLASHu] = ACTIONS(128),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(118),
    [anon_sym_BSLASHx] = ACTIONS(118),
    [anon_sym_BSLASHc] = ACTIONS(118),
    [sym_special_escape] = ACTIONS(118),
    [sym_end_assertion] = ACTIONS(118),
    [sym_non_boundary_assertion] = ACTIONS(118),
    [sym_any_character] = ACTIONS(118),
    [sym__pattern_character] = ACTIONS(118),
    [sym_null_character] = ACTIONS(118),
  },
  [21] = {
    [ts_builtin_sym_end] = ACTIONS(130),
    [sym_disjunction_delimiter] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(130),
    [anon_sym_QMARK] = ACTIONS(130),
    [anon_sym_PLUS] = ACTIONS(130),
    [anon_sym_LBRACE] = ACTIONS(130),
    [anon_sym_BSLASH] = ACTIONS(132),
    [anon_sym_BSLASHk_LT] = ACTIONS(130),
    [sym_group_begin] = ACTIONS(130),
    [sym_group_end] = ACTIONS(130),
    [anon_sym_LBRACK] = ACTIONS(130),
    [anon_sym_CARET] = ACTIONS(130),
    [anon_sym_BSLASHb] = ACTIONS(130),
    [aux_sym_character_class_escape_token1] = ACTIONS(130),
    [aux_sym_character_class_escape_token2] = ACTIONS(130),
    [anon_sym_BSLASHu] = ACTIONS(132),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(130),
    [anon_sym_BSLASHx] = ACTIONS(130),
    [anon_sym_BSLASHc] = ACTIONS(130),
    [sym_special_escape] = ACTIONS(130),
    [sym_end_assertion] = ACTIONS(130),
    [sym_non_boundary_assertion] = ACTIONS(130),
    [sym_any_character] = ACTIONS(130),
    [sym__pattern_character] = ACTIONS(130),
    [sym_null_character] = ACTIONS(130),
  },
  [22] = {
    [ts_builtin_sym_end] = ACTIONS(134),
    [sym_disjunction_delimiter] = ACTIONS(134),
    [anon_sym_STAR] = ACTIONS(134),
    [anon_sym_QMARK] = ACTIONS(134),
    [anon_sym_PLUS] = ACTIONS(134),
    [anon_sym_LBRACE] = ACTIONS(134),
    [anon_sym_BSLASH] = ACTIONS(136),
    [anon_sym_BSLASHk_LT] = ACTIONS(134),
    [sym_group_begin] = ACTIONS(134),
    [sym_group_end] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(134),
    [anon_sym_CARET] = ACTIONS(134),
    [anon_sym_BSLASHb] = ACTIONS(134),
    [aux_sym_character_class_escape_token1] = ACTIONS(134),
    [aux_sym_character_class_escape_token2] = ACTIONS(134),
    [anon_sym_BSLASHu] = ACTIONS(136),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(134),
    [anon_sym_BSLASHx] = ACTIONS(134),
    [anon_sym_BSLASHc] = ACTIONS(134),
    [sym_special_escape] = ACTIONS(134),
    [sym_end_assertion] = ACTIONS(134),
    [sym_non_boundary_assertion] = ACTIONS(134),
    [sym_any_character] = ACTIONS(134),
    [sym__pattern_character] = ACTIONS(134),
    [sym_null_character] = ACTIONS(134),
  },
  [23] = {
    [ts_builtin_sym_end] = ACTIONS(138),
    [sym_disjunction_delimiter] = ACTIONS(138),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_PLUS] = ACTIONS(138),
    [anon_sym_LBRACE] = ACTIONS(138),
    [anon_sym_BSLASH] = ACTIONS(140),
    [anon_sym_BSLASHk_LT] = ACTIONS(138),
    [sym_group_begin] = ACTIONS(138),
    [sym_group_end] = ACTIONS(138),
    [anon_sym_LBRACK] = ACTIONS(138),
    [anon_sym_CARET] = ACTIONS(138),
    [anon_sym_BSLASHb] = ACTIONS(138),
    [aux_sym_character_class_escape_token1] = ACTIONS(138),
    [aux_sym_character_class_escape_token2] = ACTIONS(138),
    [anon_sym_BSLASHu] = ACTIONS(140),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(138),
    [anon_sym_BSLASHx] = ACTIONS(138),
    [anon_sym_BSLASHc] = ACTIONS(138),
    [sym_special_escape] = ACTIONS(138),
    [sym_end_assertion] = ACTIONS(138),
    [sym_non_boundary_assertion] = ACTIONS(138),
    [sym_any_character] = ACTIONS(138),
    [sym__pattern_character] = ACTIONS(138),
    [sym_null_character] = ACTIONS(138),
  },
  [24] = {
    [ts_builtin_sym_end] = ACTIONS(142),
    [sym_disjunction_delimiter] = ACTIONS(142),
    [anon_sym_STAR] = ACTIONS(142),
    [anon_sym_QMARK] = ACTIONS(142),
    [anon_sym_PLUS] = ACTIONS(142),
    [anon_sym_LBRACE] = ACTIONS(142),
    [anon_sym_BSLASH] = ACTIONS(144),
    [anon_sym_BSLASHk_LT] = ACTIONS(142),
    [sym_group_begin] = ACTIONS(142),
    [sym_group_end] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_CARET] = ACTIONS(142),
    [anon_sym_BSLASHb] = ACTIONS(142),
    [aux_sym_character_class_escape_token1] = ACTIONS(142),
    [aux_sym_character_class_escape_token2] = ACTIONS(142),
    [anon_sym_BSLASHu] = ACTIONS(144),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(142),
    [anon_sym_BSLASHx] = ACTIONS(142),
    [anon_sym_BSLASHc] = ACTIONS(142),
    [sym_special_escape] = ACTIONS(142),
    [sym_end_assertion] = ACTIONS(142),
    [sym_non_boundary_assertion] = ACTIONS(142),
    [sym_any_character] = ACTIONS(142),
    [sym__pattern_character] = ACTIONS(142),
    [sym_null_character] = ACTIONS(142),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(146),
    [sym_disjunction_delimiter] = ACTIONS(146),
    [anon_sym_STAR] = ACTIONS(146),
    [anon_sym_QMARK] = ACTIONS(146),
    [anon_sym_PLUS] = ACTIONS(146),
    [anon_sym_LBRACE] = ACTIONS(146),
    [anon_sym_BSLASH] = ACTIONS(148),
    [anon_sym_BSLASHk_LT] = ACTIONS(146),
    [sym_group_begin] = ACTIONS(146),
    [sym_group_end] = ACTIONS(146),
    [anon_sym_LBRACK] = ACTIONS(146),
    [anon_sym_CARET] = ACTIONS(146),
    [anon_sym_BSLASHb] = ACTIONS(146),
    [aux_sym_character_class_escape_token1] = ACTIONS(146),
    [aux_sym_character_class_escape_token2] = ACTIONS(146),
    [anon_sym_BSLASHu] = ACTIONS(148),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(146),
    [anon_sym_BSLASHx] = ACTIONS(146),
    [anon_sym_BSLASHc] = ACTIONS(146),
    [sym_special_escape] = ACTIONS(146),
    [sym_end_assertion] = ACTIONS(146),
    [sym_non_boundary_assertion] = ACTIONS(146),
    [sym_any_character] = ACTIONS(146),
    [sym__pattern_character] = ACTIONS(146),
    [sym_null_character] = ACTIONS(146),
  },
  [26] = {
    [ts_builtin_sym_end] = ACTIONS(150),
    [sym_disjunction_delimiter] = ACTIONS(150),
    [anon_sym_STAR] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(150),
    [anon_sym_PLUS] = ACTIONS(150),
    [anon_sym_LBRACE] = ACTIONS(150),
    [anon_sym_BSLASH] = ACTIONS(152),
    [anon_sym_BSLASHk_LT] = ACTIONS(150),
    [sym_group_begin] = ACTIONS(150),
    [sym_group_end] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_CARET] = ACTIONS(150),
    [anon_sym_BSLASHb] = ACTIONS(150),
    [aux_sym_character_class_escape_token1] = ACTIONS(150),
    [aux_sym_character_class_escape_token2] = ACTIONS(150),
    [anon_sym_BSLASHu] = ACTIONS(152),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(150),
    [anon_sym_BSLASHx] = ACTIONS(150),
    [anon_sym_BSLASHc] = ACTIONS(150),
    [sym_special_escape] = ACTIONS(150),
    [sym_end_assertion] = ACTIONS(150),
    [sym_non_boundary_assertion] = ACTIONS(150),
    [sym_any_character] = ACTIONS(150),
    [sym__pattern_character] = ACTIONS(150),
    [sym_null_character] = ACTIONS(150),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(154),
    [sym_disjunction_delimiter] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(154),
    [anon_sym_QMARK] = ACTIONS(154),
    [anon_sym_PLUS] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(154),
    [anon_sym_BSLASH] = ACTIONS(156),
    [anon_sym_BSLASHk_LT] = ACTIONS(154),
    [sym_group_begin] = ACTIONS(154),
    [sym_group_end] = ACTIONS(154),
    [anon_sym_LBRACK] = ACTIONS(154),
    [anon_sym_CARET] = ACTIONS(154),
    [anon_sym_BSLASHb] = ACTIONS(154),
    [aux_sym_character_class_escape_token1] = ACTIONS(154),
    [aux_sym_character_class_escape_token2] = ACTIONS(154),
    [anon_sym_BSLASHu] = ACTIONS(156),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(154),
    [anon_sym_BSLASHx] = ACTIONS(154),
    [anon_sym_BSLASHc] = ACTIONS(154),
    [sym_special_escape] = ACTIONS(154),
    [sym_end_assertion] = ACTIONS(154),
    [sym_non_boundary_assertion] = ACTIONS(154),
    [sym_any_character] = ACTIONS(154),
    [sym__pattern_character] = ACTIONS(154),
    [sym_null_character] = ACTIONS(154),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(158),
    [sym_disjunction_delimiter] = ACTIONS(158),
    [anon_sym_STAR] = ACTIONS(158),
    [anon_sym_QMARK] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(158),
    [anon_sym_LBRACE] = ACTIONS(158),
    [anon_sym_BSLASH] = ACTIONS(160),
    [anon_sym_BSLASHk_LT] = ACTIONS(158),
    [sym_group_begin] = ACTIONS(158),
    [sym_group_end] = ACTIONS(158),
    [anon_sym_LBRACK] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(158),
    [anon_sym_BSLASHb] = ACTIONS(158),
    [aux_sym_character_class_escape_token1] = ACTIONS(158),
    [aux_sym_character_class_escape_token2] = ACTIONS(158),
    [anon_sym_BSLASHu] = ACTIONS(160),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(158),
    [anon_sym_BSLASHx] = ACTIONS(158),
    [anon_sym_BSLASHc] = ACTIONS(158),
    [sym_special_escape] = ACTIONS(158),
    [sym_end_assertion] = ACTIONS(158),
    [sym_non_boundary_assertion] = ACTIONS(158),
    [sym_any_character] = ACTIONS(158),
    [sym__pattern_character] = ACTIONS(158),
    [sym_null_character] = ACTIONS(158),
  },
  [29] = {
    [ts_builtin_sym_end] = ACTIONS(162),
    [sym_disjunction_delimiter] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(162),
    [anon_sym_QMARK] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(162),
    [anon_sym_BSLASH] = ACTIONS(164),
    [anon_sym_BSLASHk_LT] = ACTIONS(162),
    [sym_group_begin] = ACTIONS(162),
    [sym_group_end] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(162),
    [anon_sym_CARET] = ACTIONS(162),
    [anon_sym_BSLASHb] = ACTIONS(162),
    [aux_sym_character_class_escape_token1] = ACTIONS(162),
    [aux_sym_character_class_escape_token2] = ACTIONS(162),
    [anon_sym_BSLASHu] = ACTIONS(164),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(162),
    [anon_sym_BSLASHx] = ACTIONS(162),
    [anon_sym_BSLASHc] = ACTIONS(162),
    [sym_special_escape] = ACTIONS(162),
    [sym_end_assertion] = ACTIONS(162),
    [sym_non_boundary_assertion] = ACTIONS(162),
    [sym_any_character] = ACTIONS(162),
    [sym__pattern_character] = ACTIONS(162),
    [sym_null_character] = ACTIONS(162),
  },
  [30] = {
    [ts_builtin_sym_end] = ACTIONS(166),
    [sym_disjunction_delimiter] = ACTIONS(166),
    [anon_sym_STAR] = ACTIONS(166),
    [anon_sym_QMARK] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(166),
    [anon_sym_BSLASH] = ACTIONS(168),
    [anon_sym_BSLASHk_LT] = ACTIONS(166),
    [sym_group_begin] = ACTIONS(166),
    [sym_group_end] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_CARET] = ACTIONS(166),
    [anon_sym_BSLASHb] = ACTIONS(166),
    [aux_sym_character_class_escape_token1] = ACTIONS(166),
    [aux_sym_character_class_escape_token2] = ACTIONS(166),
    [anon_sym_BSLASHu] = ACTIONS(168),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(166),
    [anon_sym_BSLASHx] = ACTIONS(166),
    [anon_sym_BSLASHc] = ACTIONS(166),
    [sym_special_escape] = ACTIONS(166),
    [sym_end_assertion] = ACTIONS(166),
    [sym_non_boundary_assertion] = ACTIONS(166),
    [sym_any_character] = ACTIONS(166),
    [sym__pattern_character] = ACTIONS(166),
    [sym_null_character] = ACTIONS(166),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(170),
    [sym_disjunction_delimiter] = ACTIONS(170),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_LBRACE] = ACTIONS(170),
    [anon_sym_BSLASH] = ACTIONS(172),
    [anon_sym_BSLASHk_LT] = ACTIONS(170),
    [sym_group_begin] = ACTIONS(170),
    [sym_group_end] = ACTIONS(170),
    [anon_sym_LBRACK] = ACTIONS(170),
    [anon_sym_CARET] = ACTIONS(170),
    [anon_sym_BSLASHb] = ACTIONS(170),
    [aux_sym_character_class_escape_token1] = ACTIONS(170),
    [aux_sym_character_class_escape_token2] = ACTIONS(170),
    [anon_sym_BSLASHu] = ACTIONS(172),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(170),
    [anon_sym_BSLASHx] = ACTIONS(170),
    [anon_sym_BSLASHc] = ACTIONS(170),
    [sym_special_escape] = ACTIONS(170),
    [sym_end_assertion] = ACTIONS(170),
    [sym_non_boundary_assertion] = ACTIONS(170),
    [sym_any_character] = ACTIONS(170),
    [sym__pattern_character] = ACTIONS(170),
    [sym_null_character] = ACTIONS(170),
  },
  [32] = {
    [ts_builtin_sym_end] = ACTIONS(174),
    [sym_disjunction_delimiter] = ACTIONS(174),
    [anon_sym_STAR] = ACTIONS(174),
    [anon_sym_QMARK] = ACTIONS(174),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_LBRACE] = ACTIONS(174),
    [anon_sym_BSLASH] = ACTIONS(176),
    [anon_sym_BSLASHk_LT] = ACTIONS(174),
    [sym_group_begin] = ACTIONS(174),
    [sym_group_end] = ACTIONS(174),
    [anon_sym_LBRACK] = ACTIONS(174),
    [anon_sym_CARET] = ACTIONS(174),
    [anon_sym_BSLASHb] = ACTIONS(174),
    [aux_sym_character_class_escape_token1] = ACTIONS(174),
    [aux_sym_character_class_escape_token2] = ACTIONS(174),
    [anon_sym_BSLASHu] = ACTIONS(176),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(174),
    [anon_sym_BSLASHx] = ACTIONS(174),
    [anon_sym_BSLASHc] = ACTIONS(174),
    [sym_special_escape] = ACTIONS(174),
    [sym_end_assertion] = ACTIONS(174),
    [sym_non_boundary_assertion] = ACTIONS(174),
    [sym_any_character] = ACTIONS(174),
    [sym__pattern_character] = ACTIONS(174),
    [sym_null_character] = ACTIONS(174),
  },
  [33] = {
    [ts_builtin_sym_end] = ACTIONS(178),
    [sym_disjunction_delimiter] = ACTIONS(178),
    [anon_sym_STAR] = ACTIONS(178),
    [anon_sym_QMARK] = ACTIONS(178),
    [anon_sym_PLUS] = ACTIONS(178),
    [anon_sym_LBRACE] = ACTIONS(178),
    [anon_sym_BSLASH] = ACTIONS(180),
    [anon_sym_BSLASHk_LT] = ACTIONS(178),
    [sym_group_begin] = ACTIONS(178),
    [sym_group_end] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(178),
    [anon_sym_CARET] = ACTIONS(178),
    [anon_sym_BSLASHb] = ACTIONS(178),
    [aux_sym_character_class_escape_token1] = ACTIONS(178),
    [aux_sym_character_class_escape_token2] = ACTIONS(178),
    [anon_sym_BSLASHu] = ACTIONS(180),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(178),
    [anon_sym_BSLASHx] = ACTIONS(178),
    [anon_sym_BSLASHc] = ACTIONS(178),
    [sym_special_escape] = ACTIONS(178),
    [sym_end_assertion] = ACTIONS(178),
    [sym_non_boundary_assertion] = ACTIONS(178),
    [sym_any_character] = ACTIONS(178),
    [sym__pattern_character] = ACTIONS(178),
    [sym_null_character] = ACTIONS(178),
  },
  [34] = {
    [ts_builtin_sym_end] = ACTIONS(182),
    [sym_disjunction_delimiter] = ACTIONS(182),
    [anon_sym_STAR] = ACTIONS(182),
    [anon_sym_QMARK] = ACTIONS(182),
    [anon_sym_PLUS] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(182),
    [anon_sym_BSLASH] = ACTIONS(184),
    [anon_sym_BSLASHk_LT] = ACTIONS(182),
    [sym_group_begin] = ACTIONS(182),
    [sym_group_end] = ACTIONS(182),
    [anon_sym_LBRACK] = ACTIONS(182),
    [anon_sym_CARET] = ACTIONS(182),
    [anon_sym_BSLASHb] = ACTIONS(182),
    [aux_sym_character_class_escape_token1] = ACTIONS(182),
    [aux_sym_character_class_escape_token2] = ACTIONS(182),
    [anon_sym_BSLASHu] = ACTIONS(184),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(182),
    [anon_sym_BSLASHx] = ACTIONS(182),
    [anon_sym_BSLASHc] = ACTIONS(182),
    [sym_special_escape] = ACTIONS(182),
    [sym_end_assertion] = ACTIONS(182),
    [sym_non_boundary_assertion] = ACTIONS(182),
    [sym_any_character] = ACTIONS(182),
    [sym__pattern_character] = ACTIONS(182),
    [sym_null_character] = ACTIONS(182),
  },
  [35] = {
    [ts_builtin_sym_end] = ACTIONS(186),
    [sym_disjunction_delimiter] = ACTIONS(186),
    [anon_sym_STAR] = ACTIONS(186),
    [anon_sym_QMARK] = ACTIONS(186),
    [anon_sym_PLUS] = ACTIONS(186),
    [anon_sym_LBRACE] = ACTIONS(186),
    [anon_sym_BSLASH] = ACTIONS(188),
    [anon_sym_BSLASHk_LT] = ACTIONS(186),
    [sym_group_begin] = ACTIONS(186),
    [sym_group_end] = ACTIONS(186),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_CARET] = ACTIONS(186),
    [anon_sym_BSLASHb] = ACTIONS(186),
    [aux_sym_character_class_escape_token1] = ACTIONS(186),
    [aux_sym_character_class_escape_token2] = ACTIONS(186),
    [anon_sym_BSLASHu] = ACTIONS(188),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(186),
    [anon_sym_BSLASHx] = ACTIONS(186),
    [anon_sym_BSLASHc] = ACTIONS(186),
    [sym_special_escape] = ACTIONS(186),
    [sym_end_assertion] = ACTIONS(186),
    [sym_non_boundary_assertion] = ACTIONS(186),
    [sym_any_character] = ACTIONS(186),
    [sym__pattern_character] = ACTIONS(186),
    [sym_null_character] = ACTIONS(186),
  },
  [36] = {
    [ts_builtin_sym_end] = ACTIONS(190),
    [sym_disjunction_delimiter] = ACTIONS(190),
    [anon_sym_STAR] = ACTIONS(190),
    [anon_sym_QMARK] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(190),
    [anon_sym_BSLASH] = ACTIONS(192),
    [anon_sym_BSLASHk_LT] = ACTIONS(190),
    [sym_group_begin] = ACTIONS(190),
    [sym_group_end] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(190),
    [anon_sym_CARET] = ACTIONS(190),
    [anon_sym_BSLASHb] = ACTIONS(190),
    [aux_sym_character_class_escape_token1] = ACTIONS(190),
    [aux_sym_character_class_escape_token2] = ACTIONS(190),
    [anon_sym_BSLASHu] = ACTIONS(192),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(190),
    [anon_sym_BSLASHx] = ACTIONS(190),
    [anon_sym_BSLASHc] = ACTIONS(190),
    [sym_special_escape] = ACTIONS(190),
    [sym_end_assertion] = ACTIONS(190),
    [sym_non_boundary_assertion] = ACTIONS(190),
    [sym_any_character] = ACTIONS(190),
    [sym__pattern_character] = ACTIONS(190),
    [sym_null_character] = ACTIONS(190),
  },
  [37] = {
    [ts_builtin_sym_end] = ACTIONS(194),
    [sym_disjunction_delimiter] = ACTIONS(194),
    [anon_sym_STAR] = ACTIONS(194),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(194),
    [anon_sym_LBRACE] = ACTIONS(194),
    [anon_sym_BSLASH] = ACTIONS(196),
    [anon_sym_BSLASHk_LT] = ACTIONS(194),
    [sym_group_begin] = ACTIONS(194),
    [sym_group_end] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(194),
    [anon_sym_CARET] = ACTIONS(194),
    [anon_sym_BSLASHb] = ACTIONS(194),
    [aux_sym_character_class_escape_token1] = ACTIONS(194),
    [aux_sym_character_class_escape_token2] = ACTIONS(194),
    [anon_sym_BSLASHu] = ACTIONS(196),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(194),
    [anon_sym_BSLASHx] = ACTIONS(194),
    [anon_sym_BSLASHc] = ACTIONS(194),
    [sym_special_escape] = ACTIONS(194),
    [sym_end_assertion] = ACTIONS(194),
    [sym_non_boundary_assertion] = ACTIONS(194),
    [sym_any_character] = ACTIONS(194),
    [sym__pattern_character] = ACTIONS(194),
    [sym_null_character] = ACTIONS(194),
  },
  [38] = {
    [ts_builtin_sym_end] = ACTIONS(198),
    [sym_disjunction_delimiter] = ACTIONS(198),
    [anon_sym_STAR] = ACTIONS(198),
    [anon_sym_QMARK] = ACTIONS(198),
    [anon_sym_PLUS] = ACTIONS(198),
    [anon_sym_LBRACE] = ACTIONS(198),
    [anon_sym_BSLASH] = ACTIONS(200),
    [anon_sym_BSLASHk_LT] = ACTIONS(198),
    [sym_group_begin] = ACTIONS(198),
    [sym_group_end] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_CARET] = ACTIONS(198),
    [anon_sym_BSLASHb] = ACTIONS(198),
    [aux_sym_character_class_escape_token1] = ACTIONS(198),
    [aux_sym_character_class_escape_token2] = ACTIONS(198),
    [anon_sym_BSLASHu] = ACTIONS(200),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(198),
    [anon_sym_BSLASHx] = ACTIONS(198),
    [anon_sym_BSLASHc] = ACTIONS(198),
    [sym_special_escape] = ACTIONS(198),
    [sym_end_assertion] = ACTIONS(198),
    [sym_non_boundary_assertion] = ACTIONS(198),
    [sym_any_character] = ACTIONS(198),
    [sym__pattern_character] = ACTIONS(198),
    [sym_null_character] = ACTIONS(198),
  },
  [39] = {
    [ts_builtin_sym_end] = ACTIONS(202),
    [sym_disjunction_delimiter] = ACTIONS(202),
    [anon_sym_STAR] = ACTIONS(202),
    [anon_sym_QMARK] = ACTIONS(202),
    [anon_sym_PLUS] = ACTIONS(202),
    [anon_sym_LBRACE] = ACTIONS(202),
    [anon_sym_BSLASH] = ACTIONS(204),
    [anon_sym_BSLASHk_LT] = ACTIONS(202),
    [sym_group_begin] = ACTIONS(202),
    [sym_group_end] = ACTIONS(202),
    [anon_sym_LBRACK] = ACTIONS(202),
    [anon_sym_CARET] = ACTIONS(202),
    [anon_sym_BSLASHb] = ACTIONS(202),
    [aux_sym_character_class_escape_token1] = ACTIONS(202),
    [aux_sym_character_class_escape_token2] = ACTIONS(202),
    [anon_sym_BSLASHu] = ACTIONS(204),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(202),
    [anon_sym_BSLASHx] = ACTIONS(202),
    [anon_sym_BSLASHc] = ACTIONS(202),
    [sym_special_escape] = ACTIONS(202),
    [sym_end_assertion] = ACTIONS(202),
    [sym_non_boundary_assertion] = ACTIONS(202),
    [sym_any_character] = ACTIONS(202),
    [sym__pattern_character] = ACTIONS(202),
    [sym_null_character] = ACTIONS(202),
  },
  [40] = {
    [ts_builtin_sym_end] = ACTIONS(206),
    [sym_disjunction_delimiter] = ACTIONS(206),
    [anon_sym_STAR] = ACTIONS(206),
    [anon_sym_QMARK] = ACTIONS(206),
    [anon_sym_PLUS] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_BSLASH] = ACTIONS(208),
    [anon_sym_BSLASHk_LT] = ACTIONS(206),
    [sym_group_begin] = ACTIONS(206),
    [sym_group_end] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_CARET] = ACTIONS(206),
    [anon_sym_BSLASHb] = ACTIONS(206),
    [aux_sym_character_class_escape_token1] = ACTIONS(206),
    [aux_sym_character_class_escape_token2] = ACTIONS(206),
    [anon_sym_BSLASHu] = ACTIONS(208),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(206),
    [anon_sym_BSLASHx] = ACTIONS(206),
    [anon_sym_BSLASHc] = ACTIONS(206),
    [sym_special_escape] = ACTIONS(206),
    [sym_end_assertion] = ACTIONS(206),
    [sym_non_boundary_assertion] = ACTIONS(206),
    [sym_any_character] = ACTIONS(206),
    [sym__pattern_character] = ACTIONS(206),
    [sym_null_character] = ACTIONS(206),
  },
  [41] = {
    [ts_builtin_sym_end] = ACTIONS(210),
    [sym_disjunction_delimiter] = ACTIONS(210),
    [anon_sym_STAR] = ACTIONS(210),
    [anon_sym_QMARK] = ACTIONS(210),
    [anon_sym_PLUS] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_BSLASH] = ACTIONS(212),
    [anon_sym_BSLASHk_LT] = ACTIONS(210),
    [sym_group_begin] = ACTIONS(210),
    [sym_group_end] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_CARET] = ACTIONS(210),
    [anon_sym_BSLASHb] = ACTIONS(210),
    [aux_sym_character_class_escape_token1] = ACTIONS(210),
    [aux_sym_character_class_escape_token2] = ACTIONS(210),
    [anon_sym_BSLASHu] = ACTIONS(212),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(210),
    [anon_sym_BSLASHx] = ACTIONS(210),
    [anon_sym_BSLASHc] = ACTIONS(210),
    [sym_special_escape] = ACTIONS(210),
    [sym_end_assertion] = ACTIONS(210),
    [sym_non_boundary_assertion] = ACTIONS(210),
    [sym_any_character] = ACTIONS(210),
    [sym__pattern_character] = ACTIONS(210),
    [sym_null_character] = ACTIONS(210),
  },
  [42] = {
    [ts_builtin_sym_end] = ACTIONS(214),
    [sym_disjunction_delimiter] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(214),
    [anon_sym_QMARK] = ACTIONS(214),
    [anon_sym_PLUS] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(214),
    [anon_sym_BSLASH] = ACTIONS(216),
    [anon_sym_BSLASHk_LT] = ACTIONS(214),
    [sym_group_begin] = ACTIONS(214),
    [sym_group_end] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(214),
    [anon_sym_CARET] = ACTIONS(214),
    [anon_sym_BSLASHb] = ACTIONS(214),
    [aux_sym_character_class_escape_token1] = ACTIONS(214),
    [aux_sym_character_class_escape_token2] = ACTIONS(214),
    [anon_sym_BSLASHu] = ACTIONS(216),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(214),
    [anon_sym_BSLASHx] = ACTIONS(214),
    [anon_sym_BSLASHc] = ACTIONS(214),
    [sym_special_escape] = ACTIONS(214),
    [sym_end_assertion] = ACTIONS(214),
    [sym_non_boundary_assertion] = ACTIONS(214),
    [sym_any_character] = ACTIONS(214),
    [sym__pattern_character] = ACTIONS(214),
    [sym_null_character] = ACTIONS(214),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(218),
    [sym_disjunction_delimiter] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(218),
    [anon_sym_QMARK] = ACTIONS(218),
    [anon_sym_PLUS] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_BSLASHk_LT] = ACTIONS(218),
    [sym_group_begin] = ACTIONS(218),
    [sym_group_end] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_CARET] = ACTIONS(218),
    [anon_sym_BSLASHb] = ACTIONS(218),
    [aux_sym_character_class_escape_token1] = ACTIONS(218),
    [aux_sym_character_class_escape_token2] = ACTIONS(218),
    [anon_sym_BSLASHu] = ACTIONS(220),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(218),
    [anon_sym_BSLASHx] = ACTIONS(218),
    [anon_sym_BSLASHc] = ACTIONS(218),
    [sym_special_escape] = ACTIONS(218),
    [sym_end_assertion] = ACTIONS(218),
    [sym_non_boundary_assertion] = ACTIONS(218),
    [sym_any_character] = ACTIONS(218),
    [sym__pattern_character] = ACTIONS(218),
    [sym_null_character] = ACTIONS(218),
  },
  [44] = {
    [ts_builtin_sym_end] = ACTIONS(222),
    [sym_disjunction_delimiter] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(222),
    [anon_sym_QMARK] = ACTIONS(222),
    [anon_sym_PLUS] = ACTIONS(222),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_BSLASH] = ACTIONS(224),
    [anon_sym_BSLASHk_LT] = ACTIONS(222),
    [sym_group_begin] = ACTIONS(222),
    [sym_group_end] = ACTIONS(222),
    [anon_sym_LBRACK] = ACTIONS(222),
    [anon_sym_CARET] = ACTIONS(222),
    [anon_sym_BSLASHb] = ACTIONS(222),
    [aux_sym_character_class_escape_token1] = ACTIONS(222),
    [aux_sym_character_class_escape_token2] = ACTIONS(222),
    [anon_sym_BSLASHu] = ACTIONS(224),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(222),
    [anon_sym_BSLASHx] = ACTIONS(222),
    [anon_sym_BSLASHc] = ACTIONS(222),
    [sym_special_escape] = ACTIONS(222),
    [sym_end_assertion] = ACTIONS(222),
    [sym_non_boundary_assertion] = ACTIONS(222),
    [sym_any_character] = ACTIONS(222),
    [sym__pattern_character] = ACTIONS(222),
    [sym_null_character] = ACTIONS(222),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(226),
    [sym_disjunction_delimiter] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(226),
    [anon_sym_QMARK] = ACTIONS(226),
    [anon_sym_PLUS] = ACTIONS(226),
    [anon_sym_LBRACE] = ACTIONS(226),
    [anon_sym_BSLASH] = ACTIONS(228),
    [anon_sym_BSLASHk_LT] = ACTIONS(226),
    [sym_group_begin] = ACTIONS(226),
    [sym_group_end] = ACTIONS(226),
    [anon_sym_LBRACK] = ACTIONS(226),
    [anon_sym_CARET] = ACTIONS(226),
    [anon_sym_BSLASHb] = ACTIONS(226),
    [aux_sym_character_class_escape_token1] = ACTIONS(226),
    [aux_sym_character_class_escape_token2] = ACTIONS(226),
    [anon_sym_BSLASHu] = ACTIONS(228),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(226),
    [anon_sym_BSLASHx] = ACTIONS(226),
    [anon_sym_BSLASHc] = ACTIONS(226),
    [sym_special_escape] = ACTIONS(226),
    [sym_end_assertion] = ACTIONS(226),
    [sym_non_boundary_assertion] = ACTIONS(226),
    [sym_any_character] = ACTIONS(226),
    [sym__pattern_character] = ACTIONS(226),
    [sym_null_character] = ACTIONS(226),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(230),
    [sym_disjunction_delimiter] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(230),
    [anon_sym_QMARK] = ACTIONS(230),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(230),
    [anon_sym_BSLASH] = ACTIONS(232),
    [anon_sym_BSLASHk_LT] = ACTIONS(230),
    [sym_group_begin] = ACTIONS(230),
    [sym_group_end] = ACTIONS(230),
    [anon_sym_LBRACK] = ACTIONS(230),
    [anon_sym_CARET] = ACTIONS(230),
    [anon_sym_BSLASHb] = ACTIONS(230),
    [aux_sym_character_class_escape_token1] = ACTIONS(230),
    [aux_sym_character_class_escape_token2] = ACTIONS(230),
    [anon_sym_BSLASHu] = ACTIONS(232),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(230),
    [anon_sym_BSLASHx] = ACTIONS(230),
    [anon_sym_BSLASHc] = ACTIONS(230),
    [sym_special_escape] = ACTIONS(230),
    [sym_end_assertion] = ACTIONS(230),
    [sym_non_boundary_assertion] = ACTIONS(230),
    [sym_any_character] = ACTIONS(230),
    [sym__pattern_character] = ACTIONS(230),
    [sym_null_character] = ACTIONS(230),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(234),
    [sym_disjunction_delimiter] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(234),
    [anon_sym_QMARK] = ACTIONS(234),
    [anon_sym_PLUS] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_BSLASH] = ACTIONS(236),
    [anon_sym_BSLASHk_LT] = ACTIONS(234),
    [sym_group_begin] = ACTIONS(234),
    [sym_group_end] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_CARET] = ACTIONS(234),
    [anon_sym_BSLASHb] = ACTIONS(234),
    [aux_sym_character_class_escape_token1] = ACTIONS(234),
    [aux_sym_character_class_escape_token2] = ACTIONS(234),
    [anon_sym_BSLASHu] = ACTIONS(236),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(234),
    [anon_sym_BSLASHx] = ACTIONS(234),
    [anon_sym_BSLASHc] = ACTIONS(234),
    [sym_special_escape] = ACTIONS(234),
    [sym_end_assertion] = ACTIONS(234),
    [sym_non_boundary_assertion] = ACTIONS(234),
    [sym_any_character] = ACTIONS(234),
    [sym__pattern_character] = ACTIONS(234),
    [sym_null_character] = ACTIONS(234),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(238),
    [sym_disjunction_delimiter] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_QMARK] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_BSLASH] = ACTIONS(240),
    [anon_sym_BSLASHk_LT] = ACTIONS(238),
    [sym_group_begin] = ACTIONS(238),
    [sym_group_end] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_CARET] = ACTIONS(238),
    [anon_sym_BSLASHb] = ACTIONS(238),
    [aux_sym_character_class_escape_token1] = ACTIONS(238),
    [aux_sym_character_class_escape_token2] = ACTIONS(238),
    [anon_sym_BSLASHu] = ACTIONS(240),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(238),
    [anon_sym_BSLASHx] = ACTIONS(238),
    [anon_sym_BSLASHc] = ACTIONS(238),
    [sym_special_escape] = ACTIONS(238),
    [sym_end_assertion] = ACTIONS(238),
    [sym_non_boundary_assertion] = ACTIONS(238),
    [sym_any_character] = ACTIONS(238),
    [sym__pattern_character] = ACTIONS(238),
    [sym_null_character] = ACTIONS(238),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(242),
    [sym_disjunction_delimiter] = ACTIONS(242),
    [anon_sym_STAR] = ACTIONS(242),
    [anon_sym_QMARK] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(242),
    [anon_sym_BSLASH] = ACTIONS(244),
    [anon_sym_BSLASHk_LT] = ACTIONS(242),
    [sym_group_begin] = ACTIONS(242),
    [sym_group_end] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(242),
    [anon_sym_BSLASHb] = ACTIONS(242),
    [aux_sym_character_class_escape_token1] = ACTIONS(242),
    [aux_sym_character_class_escape_token2] = ACTIONS(242),
    [anon_sym_BSLASHu] = ACTIONS(244),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(242),
    [anon_sym_BSLASHx] = ACTIONS(242),
    [anon_sym_BSLASHc] = ACTIONS(242),
    [sym_special_escape] = ACTIONS(242),
    [sym_end_assertion] = ACTIONS(242),
    [sym_non_boundary_assertion] = ACTIONS(242),
    [sym_any_character] = ACTIONS(242),
    [sym__pattern_character] = ACTIONS(242),
    [sym_null_character] = ACTIONS(242),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(246),
    [sym_disjunction_delimiter] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_QMARK] = ACTIONS(246),
    [anon_sym_PLUS] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_BSLASH] = ACTIONS(248),
    [anon_sym_BSLASHk_LT] = ACTIONS(246),
    [sym_group_begin] = ACTIONS(246),
    [sym_group_end] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_CARET] = ACTIONS(246),
    [anon_sym_BSLASHb] = ACTIONS(246),
    [aux_sym_character_class_escape_token1] = ACTIONS(246),
    [aux_sym_character_class_escape_token2] = ACTIONS(246),
    [anon_sym_BSLASHu] = ACTIONS(248),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(246),
    [anon_sym_BSLASHx] = ACTIONS(246),
    [anon_sym_BSLASHc] = ACTIONS(246),
    [sym_special_escape] = ACTIONS(246),
    [sym_end_assertion] = ACTIONS(246),
    [sym_non_boundary_assertion] = ACTIONS(246),
    [sym_any_character] = ACTIONS(246),
    [sym__pattern_character] = ACTIONS(246),
    [sym_null_character] = ACTIONS(246),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_disjunction_delimiter] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_QMARK] = ACTIONS(250),
    [anon_sym_PLUS] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_BSLASH] = ACTIONS(252),
    [anon_sym_BSLASHk_LT] = ACTIONS(250),
    [sym_group_begin] = ACTIONS(250),
    [sym_group_end] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_CARET] = ACTIONS(250),
    [anon_sym_BSLASHb] = ACTIONS(250),
    [aux_sym_character_class_escape_token1] = ACTIONS(250),
    [aux_sym_character_class_escape_token2] = ACTIONS(250),
    [anon_sym_BSLASHu] = ACTIONS(252),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(250),
    [anon_sym_BSLASHx] = ACTIONS(250),
    [anon_sym_BSLASHc] = ACTIONS(250),
    [sym_special_escape] = ACTIONS(250),
    [sym_end_assertion] = ACTIONS(250),
    [sym_non_boundary_assertion] = ACTIONS(250),
    [sym_any_character] = ACTIONS(250),
    [sym__pattern_character] = ACTIONS(250),
    [sym_null_character] = ACTIONS(250),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(254),
    [sym_disjunction_delimiter] = ACTIONS(254),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_QMARK] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(254),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_BSLASHk_LT] = ACTIONS(254),
    [sym_group_begin] = ACTIONS(254),
    [sym_group_end] = ACTIONS(254),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(254),
    [anon_sym_BSLASHb] = ACTIONS(254),
    [aux_sym_character_class_escape_token1] = ACTIONS(254),
    [aux_sym_character_class_escape_token2] = ACTIONS(254),
    [anon_sym_BSLASHu] = ACTIONS(256),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(254),
    [anon_sym_BSLASHx] = ACTIONS(254),
    [anon_sym_BSLASHc] = ACTIONS(254),
    [sym_special_escape] = ACTIONS(254),
    [sym_end_assertion] = ACTIONS(254),
    [sym_non_boundary_assertion] = ACTIONS(254),
    [sym_any_character] = ACTIONS(254),
    [sym__pattern_character] = ACTIONS(254),
    [sym_null_character] = ACTIONS(254),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(258),
    [sym_disjunction_delimiter] = ACTIONS(258),
    [anon_sym_STAR] = ACTIONS(258),
    [anon_sym_QMARK] = ACTIONS(258),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(258),
    [anon_sym_BSLASH] = ACTIONS(260),
    [anon_sym_BSLASHk_LT] = ACTIONS(258),
    [sym_group_begin] = ACTIONS(258),
    [sym_group_end] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(258),
    [anon_sym_CARET] = ACTIONS(258),
    [anon_sym_BSLASHb] = ACTIONS(258),
    [aux_sym_character_class_escape_token1] = ACTIONS(258),
    [aux_sym_character_class_escape_token2] = ACTIONS(258),
    [anon_sym_BSLASHu] = ACTIONS(260),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(258),
    [anon_sym_BSLASHx] = ACTIONS(258),
    [anon_sym_BSLASHc] = ACTIONS(258),
    [sym_special_escape] = ACTIONS(258),
    [sym_end_assertion] = ACTIONS(258),
    [sym_non_boundary_assertion] = ACTIONS(258),
    [sym_any_character] = ACTIONS(258),
    [sym__pattern_character] = ACTIONS(258),
    [sym_null_character] = ACTIONS(258),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(262),
    [sym_disjunction_delimiter] = ACTIONS(262),
    [anon_sym_STAR] = ACTIONS(262),
    [anon_sym_QMARK] = ACTIONS(262),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(262),
    [anon_sym_BSLASH] = ACTIONS(264),
    [anon_sym_BSLASHk_LT] = ACTIONS(262),
    [sym_group_begin] = ACTIONS(262),
    [sym_group_end] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_BSLASHb] = ACTIONS(262),
    [aux_sym_character_class_escape_token1] = ACTIONS(262),
    [aux_sym_character_class_escape_token2] = ACTIONS(262),
    [anon_sym_BSLASHu] = ACTIONS(264),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(262),
    [anon_sym_BSLASHx] = ACTIONS(262),
    [anon_sym_BSLASHc] = ACTIONS(262),
    [sym_special_escape] = ACTIONS(262),
    [sym_end_assertion] = ACTIONS(262),
    [sym_non_boundary_assertion] = ACTIONS(262),
    [sym_any_character] = ACTIONS(262),
    [sym__pattern_character] = ACTIONS(262),
    [sym_null_character] = ACTIONS(262),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(266),
    [sym_disjunction_delimiter] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(266),
    [anon_sym_QMARK] = ACTIONS(266),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(266),
    [anon_sym_BSLASH] = ACTIONS(268),
    [anon_sym_BSLASHk_LT] = ACTIONS(266),
    [sym_group_begin] = ACTIONS(266),
    [sym_group_end] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(266),
    [anon_sym_CARET] = ACTIONS(266),
    [anon_sym_BSLASHb] = ACTIONS(266),
    [aux_sym_character_class_escape_token1] = ACTIONS(266),
    [aux_sym_character_class_escape_token2] = ACTIONS(266),
    [anon_sym_BSLASHu] = ACTIONS(268),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(266),
    [anon_sym_BSLASHx] = ACTIONS(266),
    [anon_sym_BSLASHc] = ACTIONS(266),
    [sym_special_escape] = ACTIONS(266),
    [sym_end_assertion] = ACTIONS(266),
    [sym_non_boundary_assertion] = ACTIONS(266),
    [sym_any_character] = ACTIONS(266),
    [sym__pattern_character] = ACTIONS(266),
    [sym_null_character] = ACTIONS(266),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(270),
    [sym_disjunction_delimiter] = ACTIONS(270),
    [anon_sym_STAR] = ACTIONS(270),
    [anon_sym_QMARK] = ACTIONS(270),
    [anon_sym_PLUS] = ACTIONS(270),
    [anon_sym_LBRACE] = ACTIONS(270),
    [anon_sym_BSLASH] = ACTIONS(272),
    [anon_sym_BSLASHk_LT] = ACTIONS(270),
    [sym_group_begin] = ACTIONS(270),
    [sym_group_end] = ACTIONS(270),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_CARET] = ACTIONS(270),
    [anon_sym_BSLASHb] = ACTIONS(270),
    [aux_sym_character_class_escape_token1] = ACTIONS(270),
    [aux_sym_character_class_escape_token2] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(270),
    [anon_sym_BSLASHx] = ACTIONS(270),
    [anon_sym_BSLASHc] = ACTIONS(270),
    [sym_special_escape] = ACTIONS(270),
    [sym_end_assertion] = ACTIONS(270),
    [sym_non_boundary_assertion] = ACTIONS(270),
    [sym_any_character] = ACTIONS(270),
    [sym__pattern_character] = ACTIONS(270),
    [sym_null_character] = ACTIONS(270),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(274),
    [sym_disjunction_delimiter] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(274),
    [anon_sym_QMARK] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(274),
    [anon_sym_BSLASH] = ACTIONS(276),
    [anon_sym_BSLASHk_LT] = ACTIONS(274),
    [sym_group_begin] = ACTIONS(274),
    [sym_group_end] = ACTIONS(274),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_CARET] = ACTIONS(274),
    [anon_sym_BSLASHb] = ACTIONS(274),
    [aux_sym_character_class_escape_token1] = ACTIONS(274),
    [aux_sym_character_class_escape_token2] = ACTIONS(274),
    [anon_sym_BSLASHu] = ACTIONS(276),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(274),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(274),
    [sym_special_escape] = ACTIONS(274),
    [sym_end_assertion] = ACTIONS(274),
    [sym_non_boundary_assertion] = ACTIONS(274),
    [sym_any_character] = ACTIONS(274),
    [sym__pattern_character] = ACTIONS(274),
    [sym_null_character] = ACTIONS(274),
  },
  [58] = {
    [sym_character_range] = STATE(61),
    [sym_set_identity_escape] = STATE(79),
    [sym_character_class_escape] = STATE(79),
    [sym_identity_escape] = STATE(79),
    [sym_unicode_escape] = STATE(79),
    [sym_hexadecimal_escape] = STATE(79),
    [sym_control_letter_escape] = STATE(79),
    [sym_escape_operator] = STATE(103),
    [aux_sym_character_set_repeat1] = STATE(61),
    [anon_sym_BSLASH] = ACTIONS(278),
    [anon_sym_CARET] = ACTIONS(280),
    [anon_sym_DASH] = ACTIONS(282),
    [anon_sym_RBRACK] = ACTIONS(284),
    [anon_sym_BSLASHb] = ACTIONS(286),
    [sym__set_character] = ACTIONS(288),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(292),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(302),
    [sym_null_character] = ACTIONS(302),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(304),
    [sym_disjunction_delimiter] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(308),
    [anon_sym_BSLASHk_LT] = ACTIONS(304),
    [sym_group_begin] = ACTIONS(304),
    [sym_group_end] = ACTIONS(304),
    [anon_sym_LBRACK] = ACTIONS(304),
    [anon_sym_CARET] = ACTIONS(304),
    [anon_sym_BSLASHb] = ACTIONS(304),
    [aux_sym_character_class_escape_token1] = ACTIONS(304),
    [aux_sym_character_class_escape_token2] = ACTIONS(304),
    [anon_sym_BSLASHu] = ACTIONS(308),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(304),
    [anon_sym_BSLASHx] = ACTIONS(304),
    [anon_sym_BSLASHc] = ACTIONS(304),
    [sym_special_escape] = ACTIONS(304),
    [sym_end_assertion] = ACTIONS(304),
    [sym_non_boundary_assertion] = ACTIONS(304),
    [sym_any_character] = ACTIONS(304),
    [sym__pattern_character] = ACTIONS(304),
    [sym_null_character] = ACTIONS(304),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(310),
    [sym_disjunction_delimiter] = ACTIONS(310),
    [anon_sym_QMARK] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(314),
    [anon_sym_BSLASHk_LT] = ACTIONS(310),
    [sym_group_begin] = ACTIONS(310),
    [sym_group_end] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_BSLASHb] = ACTIONS(310),
    [aux_sym_character_class_escape_token1] = ACTIONS(310),
    [aux_sym_character_class_escape_token2] = ACTIONS(310),
    [anon_sym_BSLASHu] = ACTIONS(314),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(310),
    [anon_sym_BSLASHx] = ACTIONS(310),
    [anon_sym_BSLASHc] = ACTIONS(310),
    [sym_special_escape] = ACTIONS(310),
    [sym_end_assertion] = ACTIONS(310),
    [sym_non_boundary_assertion] = ACTIONS(310),
    [sym_any_character] = ACTIONS(310),
    [sym__pattern_character] = ACTIONS(310),
    [sym_null_character] = ACTIONS(310),
  },
  [61] = {
    [sym_character_range] = STATE(66),
    [sym_set_identity_escape] = STATE(79),
    [sym_character_class_escape] = STATE(79),
    [sym_identity_escape] = STATE(79),
    [sym_unicode_escape] = STATE(79),
    [sym_hexadecimal_escape] = STATE(79),
    [sym_control_letter_escape] = STATE(79),
    [sym_escape_operator] = STATE(103),
    [aux_sym_character_set_repeat1] = STATE(66),
    [anon_sym_BSLASH] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(282),
    [anon_sym_RBRACK] = ACTIONS(316),
    [anon_sym_BSLASHb] = ACTIONS(286),
    [sym__set_character] = ACTIONS(302),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(292),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(302),
    [sym_null_character] = ACTIONS(302),
  },
  [62] = {
    [sym_character_range] = STATE(64),
    [sym_set_identity_escape] = STATE(79),
    [sym_character_class_escape] = STATE(79),
    [sym_identity_escape] = STATE(79),
    [sym_unicode_escape] = STATE(79),
    [sym_hexadecimal_escape] = STATE(79),
    [sym_control_letter_escape] = STATE(79),
    [sym_escape_operator] = STATE(103),
    [aux_sym_character_set_repeat1] = STATE(64),
    [anon_sym_BSLASH] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(282),
    [anon_sym_RBRACK] = ACTIONS(318),
    [anon_sym_BSLASHb] = ACTIONS(286),
    [sym__set_character] = ACTIONS(302),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(292),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(302),
    [sym_null_character] = ACTIONS(302),
  },
  [63] = {
    [ts_builtin_sym_end] = ACTIONS(320),
    [sym_disjunction_delimiter] = ACTIONS(320),
    [anon_sym_QMARK] = ACTIONS(322),
    [anon_sym_BSLASH] = ACTIONS(324),
    [anon_sym_BSLASHk_LT] = ACTIONS(320),
    [sym_group_begin] = ACTIONS(320),
    [sym_group_end] = ACTIONS(320),
    [anon_sym_LBRACK] = ACTIONS(320),
    [anon_sym_CARET] = ACTIONS(320),
    [anon_sym_BSLASHb] = ACTIONS(320),
    [aux_sym_character_class_escape_token1] = ACTIONS(320),
    [aux_sym_character_class_escape_token2] = ACTIONS(320),
    [anon_sym_BSLASHu] = ACTIONS(324),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(320),
    [anon_sym_BSLASHx] = ACTIONS(320),
    [anon_sym_BSLASHc] = ACTIONS(320),
    [sym_special_escape] = ACTIONS(320),
    [sym_end_assertion] = ACTIONS(320),
    [sym_non_boundary_assertion] = ACTIONS(320),
    [sym_any_character] = ACTIONS(320),
    [sym__pattern_character] = ACTIONS(320),
    [sym_null_character] = ACTIONS(320),
  },
  [64] = {
    [sym_character_range] = STATE(66),
    [sym_set_identity_escape] = STATE(79),
    [sym_character_class_escape] = STATE(79),
    [sym_identity_escape] = STATE(79),
    [sym_unicode_escape] = STATE(79),
    [sym_hexadecimal_escape] = STATE(79),
    [sym_control_letter_escape] = STATE(79),
    [sym_escape_operator] = STATE(103),
    [aux_sym_character_set_repeat1] = STATE(66),
    [anon_sym_BSLASH] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(282),
    [anon_sym_RBRACK] = ACTIONS(326),
    [anon_sym_BSLASHb] = ACTIONS(286),
    [sym__set_character] = ACTIONS(302),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(292),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(302),
    [sym_null_character] = ACTIONS(302),
  },
  [65] = {
    [ts_builtin_sym_end] = ACTIONS(328),
    [sym_disjunction_delimiter] = ACTIONS(328),
    [anon_sym_QMARK] = ACTIONS(330),
    [anon_sym_BSLASH] = ACTIONS(332),
    [anon_sym_BSLASHk_LT] = ACTIONS(328),
    [sym_group_begin] = ACTIONS(328),
    [sym_group_end] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(328),
    [anon_sym_CARET] = ACTIONS(328),
    [anon_sym_BSLASHb] = ACTIONS(328),
    [aux_sym_character_class_escape_token1] = ACTIONS(328),
    [aux_sym_character_class_escape_token2] = ACTIONS(328),
    [anon_sym_BSLASHu] = ACTIONS(332),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(328),
    [anon_sym_BSLASHx] = ACTIONS(328),
    [anon_sym_BSLASHc] = ACTIONS(328),
    [sym_special_escape] = ACTIONS(328),
    [sym_end_assertion] = ACTIONS(328),
    [sym_non_boundary_assertion] = ACTIONS(328),
    [sym_any_character] = ACTIONS(328),
    [sym__pattern_character] = ACTIONS(328),
    [sym_null_character] = ACTIONS(328),
  },
  [66] = {
    [sym_character_range] = STATE(66),
    [sym_set_identity_escape] = STATE(79),
    [sym_character_class_escape] = STATE(79),
    [sym_identity_escape] = STATE(79),
    [sym_unicode_escape] = STATE(79),
    [sym_hexadecimal_escape] = STATE(79),
    [sym_control_letter_escape] = STATE(79),
    [sym_escape_operator] = STATE(103),
    [aux_sym_character_set_repeat1] = STATE(66),
    [anon_sym_BSLASH] = ACTIONS(334),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(340),
    [anon_sym_BSLASHb] = ACTIONS(342),
    [sym__set_character] = ACTIONS(345),
    [aux_sym_character_class_escape_token1] = ACTIONS(348),
    [aux_sym_character_class_escape_token2] = ACTIONS(351),
    [anon_sym_BSLASHu] = ACTIONS(354),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(357),
    [anon_sym_BSLASHx] = ACTIONS(360),
    [anon_sym_BSLASHc] = ACTIONS(363),
    [sym_special_escape] = ACTIONS(345),
    [sym_null_character] = ACTIONS(345),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(366),
    [sym_disjunction_delimiter] = ACTIONS(366),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_BSLASH] = ACTIONS(370),
    [anon_sym_BSLASHk_LT] = ACTIONS(366),
    [sym_group_begin] = ACTIONS(366),
    [sym_group_end] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_CARET] = ACTIONS(366),
    [anon_sym_BSLASHb] = ACTIONS(366),
    [aux_sym_character_class_escape_token1] = ACTIONS(366),
    [aux_sym_character_class_escape_token2] = ACTIONS(366),
    [anon_sym_BSLASHu] = ACTIONS(370),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(366),
    [anon_sym_BSLASHx] = ACTIONS(366),
    [anon_sym_BSLASHc] = ACTIONS(366),
    [sym_special_escape] = ACTIONS(366),
    [sym_end_assertion] = ACTIONS(366),
    [sym_non_boundary_assertion] = ACTIONS(366),
    [sym_any_character] = ACTIONS(366),
    [sym__pattern_character] = ACTIONS(366),
    [sym_null_character] = ACTIONS(366),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(372),
    [sym_disjunction_delimiter] = ACTIONS(372),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASHk_LT] = ACTIONS(372),
    [sym_group_begin] = ACTIONS(372),
    [sym_group_end] = ACTIONS(372),
    [anon_sym_LBRACK] = ACTIONS(372),
    [anon_sym_CARET] = ACTIONS(372),
    [anon_sym_BSLASHb] = ACTIONS(372),
    [aux_sym_character_class_escape_token1] = ACTIONS(372),
    [aux_sym_character_class_escape_token2] = ACTIONS(372),
    [anon_sym_BSLASHu] = ACTIONS(376),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(372),
    [anon_sym_BSLASHx] = ACTIONS(372),
    [anon_sym_BSLASHc] = ACTIONS(372),
    [sym_special_escape] = ACTIONS(372),
    [sym_end_assertion] = ACTIONS(372),
    [sym_non_boundary_assertion] = ACTIONS(372),
    [sym_any_character] = ACTIONS(372),
    [sym__pattern_character] = ACTIONS(372),
    [sym_null_character] = ACTIONS(372),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(378),
    [sym_disjunction_delimiter] = ACTIONS(378),
    [anon_sym_BSLASH] = ACTIONS(380),
    [anon_sym_BSLASHk_LT] = ACTIONS(378),
    [sym_group_begin] = ACTIONS(378),
    [sym_group_end] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_CARET] = ACTIONS(378),
    [anon_sym_BSLASHb] = ACTIONS(378),
    [aux_sym_character_class_escape_token1] = ACTIONS(378),
    [aux_sym_character_class_escape_token2] = ACTIONS(378),
    [anon_sym_BSLASHu] = ACTIONS(380),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(378),
    [anon_sym_BSLASHx] = ACTIONS(378),
    [anon_sym_BSLASHc] = ACTIONS(378),
    [sym_special_escape] = ACTIONS(378),
    [sym_end_assertion] = ACTIONS(378),
    [sym_non_boundary_assertion] = ACTIONS(378),
    [sym_any_character] = ACTIONS(378),
    [sym__pattern_character] = ACTIONS(378),
    [sym_null_character] = ACTIONS(378),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(382),
    [sym_disjunction_delimiter] = ACTIONS(382),
    [anon_sym_BSLASH] = ACTIONS(384),
    [anon_sym_BSLASHk_LT] = ACTIONS(382),
    [sym_group_begin] = ACTIONS(382),
    [sym_group_end] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BSLASHb] = ACTIONS(382),
    [aux_sym_character_class_escape_token1] = ACTIONS(382),
    [aux_sym_character_class_escape_token2] = ACTIONS(382),
    [anon_sym_BSLASHu] = ACTIONS(384),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(382),
    [anon_sym_BSLASHx] = ACTIONS(382),
    [anon_sym_BSLASHc] = ACTIONS(382),
    [sym_special_escape] = ACTIONS(382),
    [sym_end_assertion] = ACTIONS(382),
    [sym_non_boundary_assertion] = ACTIONS(382),
    [sym_any_character] = ACTIONS(382),
    [sym__pattern_character] = ACTIONS(382),
    [sym_null_character] = ACTIONS(382),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(386),
    [sym_disjunction_delimiter] = ACTIONS(386),
    [anon_sym_BSLASH] = ACTIONS(388),
    [anon_sym_BSLASHk_LT] = ACTIONS(386),
    [sym_group_begin] = ACTIONS(386),
    [sym_group_end] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BSLASHb] = ACTIONS(386),
    [aux_sym_character_class_escape_token1] = ACTIONS(386),
    [aux_sym_character_class_escape_token2] = ACTIONS(386),
    [anon_sym_BSLASHu] = ACTIONS(388),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(386),
    [anon_sym_BSLASHx] = ACTIONS(386),
    [anon_sym_BSLASHc] = ACTIONS(386),
    [sym_special_escape] = ACTIONS(386),
    [sym_end_assertion] = ACTIONS(386),
    [sym_non_boundary_assertion] = ACTIONS(386),
    [sym_any_character] = ACTIONS(386),
    [sym__pattern_character] = ACTIONS(386),
    [sym_null_character] = ACTIONS(386),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(390),
    [sym_disjunction_delimiter] = ACTIONS(390),
    [anon_sym_BSLASH] = ACTIONS(392),
    [anon_sym_BSLASHk_LT] = ACTIONS(390),
    [sym_group_begin] = ACTIONS(390),
    [sym_group_end] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(390),
    [anon_sym_BSLASHb] = ACTIONS(390),
    [aux_sym_character_class_escape_token1] = ACTIONS(390),
    [aux_sym_character_class_escape_token2] = ACTIONS(390),
    [anon_sym_BSLASHu] = ACTIONS(392),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(390),
    [anon_sym_BSLASHx] = ACTIONS(390),
    [anon_sym_BSLASHc] = ACTIONS(390),
    [sym_special_escape] = ACTIONS(390),
    [sym_end_assertion] = ACTIONS(390),
    [sym_non_boundary_assertion] = ACTIONS(390),
    [sym_any_character] = ACTIONS(390),
    [sym__pattern_character] = ACTIONS(390),
    [sym_null_character] = ACTIONS(390),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(394),
    [sym_disjunction_delimiter] = ACTIONS(394),
    [anon_sym_BSLASH] = ACTIONS(396),
    [anon_sym_BSLASHk_LT] = ACTIONS(394),
    [sym_group_begin] = ACTIONS(394),
    [sym_group_end] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_CARET] = ACTIONS(394),
    [anon_sym_BSLASHb] = ACTIONS(394),
    [aux_sym_character_class_escape_token1] = ACTIONS(394),
    [aux_sym_character_class_escape_token2] = ACTIONS(394),
    [anon_sym_BSLASHu] = ACTIONS(396),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(394),
    [anon_sym_BSLASHx] = ACTIONS(394),
    [anon_sym_BSLASHc] = ACTIONS(394),
    [sym_special_escape] = ACTIONS(394),
    [sym_end_assertion] = ACTIONS(394),
    [sym_non_boundary_assertion] = ACTIONS(394),
    [sym_any_character] = ACTIONS(394),
    [sym__pattern_character] = ACTIONS(394),
    [sym_null_character] = ACTIONS(394),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(57),
    [sym_disjunction_delimiter] = ACTIONS(57),
    [anon_sym_BSLASH] = ACTIONS(398),
    [anon_sym_BSLASHk_LT] = ACTIONS(57),
    [sym_group_begin] = ACTIONS(57),
    [sym_group_end] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_BSLASHb] = ACTIONS(57),
    [aux_sym_character_class_escape_token1] = ACTIONS(57),
    [aux_sym_character_class_escape_token2] = ACTIONS(57),
    [anon_sym_BSLASHu] = ACTIONS(398),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(57),
    [anon_sym_BSLASHx] = ACTIONS(57),
    [anon_sym_BSLASHc] = ACTIONS(57),
    [sym_special_escape] = ACTIONS(57),
    [sym_end_assertion] = ACTIONS(57),
    [sym_non_boundary_assertion] = ACTIONS(57),
    [sym_any_character] = ACTIONS(57),
    [sym__pattern_character] = ACTIONS(57),
    [sym_null_character] = ACTIONS(57),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(400),
    [sym_disjunction_delimiter] = ACTIONS(400),
    [anon_sym_BSLASH] = ACTIONS(402),
    [anon_sym_BSLASHk_LT] = ACTIONS(400),
    [sym_group_begin] = ACTIONS(400),
    [sym_group_end] = ACTIONS(400),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_CARET] = ACTIONS(400),
    [anon_sym_BSLASHb] = ACTIONS(400),
    [aux_sym_character_class_escape_token1] = ACTIONS(400),
    [aux_sym_character_class_escape_token2] = ACTIONS(400),
    [anon_sym_BSLASHu] = ACTIONS(402),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(400),
    [anon_sym_BSLASHx] = ACTIONS(400),
    [anon_sym_BSLASHc] = ACTIONS(400),
    [sym_special_escape] = ACTIONS(400),
    [sym_end_assertion] = ACTIONS(400),
    [sym_non_boundary_assertion] = ACTIONS(400),
    [sym_any_character] = ACTIONS(400),
    [sym__pattern_character] = ACTIONS(400),
    [sym_null_character] = ACTIONS(400),
  },
  [76] = {
    [sym_set_identity_escape] = STATE(94),
    [sym_character_class_escape] = STATE(94),
    [sym_identity_escape] = STATE(94),
    [sym_unicode_escape] = STATE(94),
    [sym_hexadecimal_escape] = STATE(94),
    [sym_control_letter_escape] = STATE(94),
    [sym_escape_operator] = STATE(103),
    [anon_sym_BSLASH] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_RBRACK] = ACTIONS(340),
    [anon_sym_BSLASHb] = ACTIONS(406),
    [sym__set_character] = ACTIONS(404),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(292),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(404),
    [sym_null_character] = ACTIONS(404),
  },
  [77] = {
    [sym_set_identity_escape] = STATE(92),
    [sym_character_class_escape] = STATE(92),
    [sym_identity_escape] = STATE(92),
    [sym_unicode_escape] = STATE(92),
    [sym_hexadecimal_escape] = STATE(92),
    [sym_control_letter_escape] = STATE(92),
    [sym_escape_operator] = STATE(103),
    [anon_sym_BSLASH] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(408),
    [anon_sym_RBRACK] = ACTIONS(410),
    [anon_sym_BSLASHb] = ACTIONS(412),
    [sym__set_character] = ACTIONS(408),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(292),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(408),
    [sym_null_character] = ACTIONS(408),
  },
  [78] = {
    [sym_set_identity_escape] = STATE(94),
    [sym_character_class_escape] = STATE(94),
    [sym_identity_escape] = STATE(94),
    [sym_unicode_escape] = STATE(94),
    [sym_hexadecimal_escape] = STATE(94),
    [sym_control_letter_escape] = STATE(94),
    [sym_escape_operator] = STATE(103),
    [anon_sym_BSLASH] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_BSLASHb] = ACTIONS(406),
    [sym__set_character] = ACTIONS(404),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(292),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(404),
    [sym_null_character] = ACTIONS(404),
  },
  [79] = {
    [anon_sym_BSLASH] = ACTIONS(414),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_RBRACK] = ACTIONS(418),
    [anon_sym_BSLASHb] = ACTIONS(418),
    [sym__set_character] = ACTIONS(418),
    [aux_sym_character_class_escape_token1] = ACTIONS(418),
    [aux_sym_character_class_escape_token2] = ACTIONS(418),
    [anon_sym_BSLASHu] = ACTIONS(414),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(418),
    [anon_sym_BSLASHx] = ACTIONS(418),
    [anon_sym_BSLASHc] = ACTIONS(418),
    [sym_special_escape] = ACTIONS(418),
    [sym_null_character] = ACTIONS(418),
  },
  [80] = {
    [anon_sym_BSLASH] = ACTIONS(144),
    [anon_sym_DASH] = ACTIONS(142),
    [anon_sym_RBRACK] = ACTIONS(142),
    [anon_sym_BSLASHb] = ACTIONS(142),
    [sym__set_character] = ACTIONS(142),
    [aux_sym_character_class_escape_token1] = ACTIONS(142),
    [aux_sym_character_class_escape_token2] = ACTIONS(142),
    [anon_sym_BSLASHu] = ACTIONS(144),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(142),
    [anon_sym_BSLASHx] = ACTIONS(142),
    [anon_sym_BSLASHc] = ACTIONS(142),
    [sym_special_escape] = ACTIONS(142),
    [sym_null_character] = ACTIONS(142),
  },
  [81] = {
    [anon_sym_BSLASH] = ACTIONS(420),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_RBRACK] = ACTIONS(422),
    [anon_sym_BSLASHb] = ACTIONS(422),
    [sym__set_character] = ACTIONS(422),
    [aux_sym_character_class_escape_token1] = ACTIONS(422),
    [aux_sym_character_class_escape_token2] = ACTIONS(422),
    [anon_sym_BSLASHu] = ACTIONS(420),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(422),
    [anon_sym_BSLASHx] = ACTIONS(422),
    [anon_sym_BSLASHc] = ACTIONS(422),
    [sym_special_escape] = ACTIONS(422),
    [sym_null_character] = ACTIONS(422),
  },
  [82] = {
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_DASH] = ACTIONS(218),
    [anon_sym_RBRACK] = ACTIONS(218),
    [anon_sym_BSLASHb] = ACTIONS(218),
    [sym__set_character] = ACTIONS(218),
    [aux_sym_character_class_escape_token1] = ACTIONS(218),
    [aux_sym_character_class_escape_token2] = ACTIONS(218),
    [anon_sym_BSLASHu] = ACTIONS(220),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(218),
    [anon_sym_BSLASHx] = ACTIONS(218),
    [anon_sym_BSLASHc] = ACTIONS(218),
    [sym_special_escape] = ACTIONS(218),
    [sym_null_character] = ACTIONS(218),
  },
  [83] = {
    [anon_sym_BSLASH] = ACTIONS(240),
    [anon_sym_DASH] = ACTIONS(238),
    [anon_sym_RBRACK] = ACTIONS(238),
    [anon_sym_BSLASHb] = ACTIONS(238),
    [sym__set_character] = ACTIONS(238),
    [aux_sym_character_class_escape_token1] = ACTIONS(238),
    [aux_sym_character_class_escape_token2] = ACTIONS(238),
    [anon_sym_BSLASHu] = ACTIONS(240),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(238),
    [anon_sym_BSLASHx] = ACTIONS(238),
    [anon_sym_BSLASHc] = ACTIONS(238),
    [sym_special_escape] = ACTIONS(238),
    [sym_null_character] = ACTIONS(238),
  },
  [84] = {
    [anon_sym_BSLASH] = ACTIONS(148),
    [anon_sym_DASH] = ACTIONS(146),
    [anon_sym_RBRACK] = ACTIONS(146),
    [anon_sym_BSLASHb] = ACTIONS(146),
    [sym__set_character] = ACTIONS(146),
    [aux_sym_character_class_escape_token1] = ACTIONS(146),
    [aux_sym_character_class_escape_token2] = ACTIONS(146),
    [anon_sym_BSLASHu] = ACTIONS(148),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(146),
    [anon_sym_BSLASHx] = ACTIONS(146),
    [anon_sym_BSLASHc] = ACTIONS(146),
    [sym_special_escape] = ACTIONS(146),
    [sym_null_character] = ACTIONS(146),
  },
  [85] = {
    [anon_sym_BSLASH] = ACTIONS(236),
    [anon_sym_DASH] = ACTIONS(234),
    [anon_sym_RBRACK] = ACTIONS(234),
    [anon_sym_BSLASHb] = ACTIONS(234),
    [sym__set_character] = ACTIONS(234),
    [aux_sym_character_class_escape_token1] = ACTIONS(234),
    [aux_sym_character_class_escape_token2] = ACTIONS(234),
    [anon_sym_BSLASHu] = ACTIONS(236),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(234),
    [anon_sym_BSLASHx] = ACTIONS(234),
    [anon_sym_BSLASHc] = ACTIONS(234),
    [sym_special_escape] = ACTIONS(234),
    [sym_null_character] = ACTIONS(234),
  },
  [86] = {
    [anon_sym_BSLASH] = ACTIONS(232),
    [anon_sym_DASH] = ACTIONS(230),
    [anon_sym_RBRACK] = ACTIONS(230),
    [anon_sym_BSLASHb] = ACTIONS(230),
    [sym__set_character] = ACTIONS(230),
    [aux_sym_character_class_escape_token1] = ACTIONS(230),
    [aux_sym_character_class_escape_token2] = ACTIONS(230),
    [anon_sym_BSLASHu] = ACTIONS(232),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(230),
    [anon_sym_BSLASHx] = ACTIONS(230),
    [anon_sym_BSLASHc] = ACTIONS(230),
    [sym_special_escape] = ACTIONS(230),
    [sym_null_character] = ACTIONS(230),
  },
  [87] = {
    [anon_sym_BSLASH] = ACTIONS(228),
    [anon_sym_DASH] = ACTIONS(226),
    [anon_sym_RBRACK] = ACTIONS(226),
    [anon_sym_BSLASHb] = ACTIONS(226),
    [sym__set_character] = ACTIONS(226),
    [aux_sym_character_class_escape_token1] = ACTIONS(226),
    [aux_sym_character_class_escape_token2] = ACTIONS(226),
    [anon_sym_BSLASHu] = ACTIONS(228),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(226),
    [anon_sym_BSLASHx] = ACTIONS(226),
    [anon_sym_BSLASHc] = ACTIONS(226),
    [sym_special_escape] = ACTIONS(226),
    [sym_null_character] = ACTIONS(226),
  },
  [88] = {
    [anon_sym_BSLASH] = ACTIONS(252),
    [anon_sym_DASH] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(250),
    [anon_sym_BSLASHb] = ACTIONS(250),
    [sym__set_character] = ACTIONS(250),
    [aux_sym_character_class_escape_token1] = ACTIONS(250),
    [aux_sym_character_class_escape_token2] = ACTIONS(250),
    [anon_sym_BSLASHu] = ACTIONS(252),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(250),
    [anon_sym_BSLASHx] = ACTIONS(250),
    [anon_sym_BSLASHc] = ACTIONS(250),
    [sym_special_escape] = ACTIONS(250),
    [sym_null_character] = ACTIONS(250),
  },
  [89] = {
    [anon_sym_BSLASH] = ACTIONS(424),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_RBRACK] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(426),
    [sym__set_character] = ACTIONS(426),
    [aux_sym_character_class_escape_token1] = ACTIONS(426),
    [aux_sym_character_class_escape_token2] = ACTIONS(426),
    [anon_sym_BSLASHu] = ACTIONS(424),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(426),
    [anon_sym_BSLASHx] = ACTIONS(426),
    [anon_sym_BSLASHc] = ACTIONS(426),
    [sym_special_escape] = ACTIONS(426),
    [sym_null_character] = ACTIONS(426),
  },
  [90] = {
    [anon_sym_BSLASH] = ACTIONS(414),
    [anon_sym_DASH] = ACTIONS(428),
    [anon_sym_RBRACK] = ACTIONS(418),
    [anon_sym_BSLASHb] = ACTIONS(418),
    [sym__set_character] = ACTIONS(418),
    [aux_sym_character_class_escape_token1] = ACTIONS(418),
    [aux_sym_character_class_escape_token2] = ACTIONS(418),
    [anon_sym_BSLASHu] = ACTIONS(414),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(418),
    [anon_sym_BSLASHx] = ACTIONS(418),
    [anon_sym_BSLASHc] = ACTIONS(418),
    [sym_special_escape] = ACTIONS(418),
    [sym_null_character] = ACTIONS(418),
  },
  [91] = {
    [anon_sym_BSLASH] = ACTIONS(430),
    [anon_sym_DASH] = ACTIONS(432),
    [anon_sym_RBRACK] = ACTIONS(434),
    [anon_sym_BSLASHb] = ACTIONS(434),
    [sym__set_character] = ACTIONS(434),
    [aux_sym_character_class_escape_token1] = ACTIONS(434),
    [aux_sym_character_class_escape_token2] = ACTIONS(434),
    [anon_sym_BSLASHu] = ACTIONS(430),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(434),
    [anon_sym_BSLASHx] = ACTIONS(434),
    [anon_sym_BSLASHc] = ACTIONS(434),
    [sym_special_escape] = ACTIONS(434),
    [sym_null_character] = ACTIONS(434),
  },
  [92] = {
    [anon_sym_BSLASH] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(438),
    [anon_sym_RBRACK] = ACTIONS(438),
    [anon_sym_BSLASHb] = ACTIONS(438),
    [sym__set_character] = ACTIONS(438),
    [aux_sym_character_class_escape_token1] = ACTIONS(438),
    [aux_sym_character_class_escape_token2] = ACTIONS(438),
    [anon_sym_BSLASHu] = ACTIONS(436),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(438),
    [anon_sym_BSLASHx] = ACTIONS(438),
    [anon_sym_BSLASHc] = ACTIONS(438),
    [sym_special_escape] = ACTIONS(438),
    [sym_null_character] = ACTIONS(438),
  },
  [93] = {
    [anon_sym_BSLASH] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(442),
    [anon_sym_RBRACK] = ACTIONS(442),
    [anon_sym_BSLASHb] = ACTIONS(442),
    [sym__set_character] = ACTIONS(442),
    [aux_sym_character_class_escape_token1] = ACTIONS(442),
    [aux_sym_character_class_escape_token2] = ACTIONS(442),
    [anon_sym_BSLASHu] = ACTIONS(440),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(442),
    [anon_sym_BSLASHx] = ACTIONS(442),
    [anon_sym_BSLASHc] = ACTIONS(442),
    [sym_special_escape] = ACTIONS(442),
    [sym_null_character] = ACTIONS(442),
  },
  [94] = {
    [anon_sym_BSLASH] = ACTIONS(444),
    [anon_sym_DASH] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(446),
    [anon_sym_BSLASHb] = ACTIONS(446),
    [sym__set_character] = ACTIONS(446),
    [aux_sym_character_class_escape_token1] = ACTIONS(446),
    [aux_sym_character_class_escape_token2] = ACTIONS(446),
    [anon_sym_BSLASHu] = ACTIONS(444),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(446),
    [anon_sym_BSLASHx] = ACTIONS(446),
    [anon_sym_BSLASHc] = ACTIONS(446),
    [sym_special_escape] = ACTIONS(446),
    [sym_null_character] = ACTIONS(446),
  },
  [95] = {
    [sym_unicode_escape] = STATE(95),
    [aux_sym_group_name_repeat1] = STATE(95),
    [anon_sym_GT] = ACTIONS(448),
    [sym__name_additional_char] = ACTIONS(450),
    [anon_sym_BSLASHu] = ACTIONS(453),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(456),
  },
  [96] = {
    [sym_unicode_escape] = STATE(95),
    [aux_sym_group_name_repeat1] = STATE(95),
    [anon_sym_GT] = ACTIONS(459),
    [sym__name_additional_char] = ACTIONS(461),
    [anon_sym_BSLASHu] = ACTIONS(463),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(465),
  },
  [97] = {
    [sym_unicode_escape] = STATE(96),
    [aux_sym_group_name_repeat1] = STATE(96),
    [anon_sym_GT] = ACTIONS(467),
    [sym__name_additional_char] = ACTIONS(469),
    [anon_sym_BSLASHu] = ACTIONS(463),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(465),
  },
  [98] = {
    [sym_group_name] = STATE(124),
    [sym_unicode_escape] = STATE(97),
    [sym__name_first_char] = ACTIONS(471),
    [anon_sym_BSLASHu] = ACTIONS(463),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(465),
  },
  [99] = {
    [sym_group_name] = STATE(122),
    [sym_unicode_escape] = STATE(97),
    [sym__name_first_char] = ACTIONS(471),
    [anon_sym_BSLASHu] = ACTIONS(463),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(465),
  },
  [100] = {
    [anon_sym_GT] = ACTIONS(142),
    [sym__name_additional_char] = ACTIONS(142),
    [anon_sym_BSLASHu] = ACTIONS(144),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(142),
  },
  [101] = {
    [anon_sym_GT] = ACTIONS(218),
    [sym__name_additional_char] = ACTIONS(218),
    [anon_sym_BSLASHu] = ACTIONS(220),
    [anon_sym_BSLASHu_LBRACE] = ACTIONS(218),
  },
  [102] = {
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_EQ] = ACTIONS(475),
  },
  [103] = {
    [anon_sym_DASH] = ACTIONS(477),
    [aux_sym_identity_escape_token1] = ACTIONS(479),
  },
  [104] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(481),
    [anon_sym_RBRACE] = ACTIONS(483),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(485),
    [sym_group_end] = ACTIONS(485),
  },
  [106] = {
    [aux_sym_backreference_escape_token1] = ACTIONS(487),
    [aux_sym_identity_escape_token1] = ACTIONS(489),
  },
  [107] = {
    [anon_sym_DASH] = ACTIONS(489),
    [aux_sym_identity_escape_token1] = ACTIONS(489),
  },
  [108] = {
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(493),
  },
  [109] = {
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(499),
  },
  [111] = {
    [anon_sym_RBRACE] = ACTIONS(501),
  },
  [112] = {
    [aux_sym_identity_escape_token1] = ACTIONS(503),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(505),
  },
  [114] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(507),
  },
  [115] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(509),
  },
  [116] = {
    [aux_sym_unicode_escape_token2] = ACTIONS(511),
  },
  [117] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(513),
  },
  [118] = {
    [sym_group_end] = ACTIONS(515),
  },
  [119] = {
    [sym__unicode_property] = ACTIONS(517),
  },
  [120] = {
    [sym_group_end] = ACTIONS(519),
  },
  [121] = {
    [sym_group_end] = ACTIONS(521),
  },
  [122] = {
    [anon_sym_GT] = ACTIONS(523),
  },
  [123] = {
    [sym_group_end] = ACTIONS(525),
  },
  [124] = {
    [anon_sym_GT] = ACTIONS(527),
  },
  [125] = {
    [sym_group_end] = ACTIONS(529),
  },
  [126] = {
    [sym_group_end] = ACTIONS(531),
  },
  [127] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(533),
  },
  [128] = {
    [sym__unicode_property] = ACTIONS(535),
  },
  [129] = {
    [sym_group_end] = ACTIONS(537),
  },
  [130] = {
    [anon_sym_RBRACE] = ACTIONS(539),
  },
  [131] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(541),
  },
  [132] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(543),
  },
  [133] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(545),
  },
  [134] = {
    [anon_sym_RBRACE] = ACTIONS(547),
  },
  [135] = {
    [anon_sym_RBRACE] = ACTIONS(549),
  },
  [136] = {
    [anon_sym_RBRACE] = ACTIONS(551),
  },
  [137] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(553),
  },
  [138] = {
    [anon_sym_RBRACE] = ACTIONS(555),
  },
  [139] = {
    [sym__unicode_property] = ACTIONS(557),
  },
  [140] = {
    [aux_sym_unicode_escape_token2] = ACTIONS(559),
  },
  [141] = {
    [sym__unicode_property] = ACTIONS(561),
  },
  [142] = {
    [aux_sym_unicode_escape_token2] = ACTIONS(563),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT(106),
  [5] = {.count = 1, .reusable = true}, SHIFT(99),
  [7] = {.count = 1, .reusable = true}, SHIFT(2),
  [9] = {.count = 1, .reusable = true}, SHIFT(58),
  [11] = {.count = 1, .reusable = true}, SHIFT(35),
  [13] = {.count = 1, .reusable = true}, SHIFT(41),
  [15] = {.count = 1, .reusable = true}, SHIFT(51),
  [17] = {.count = 1, .reusable = true}, SHIFT(119),
  [19] = {.count = 1, .reusable = false}, SHIFT(117),
  [21] = {.count = 1, .reusable = true}, SHIFT(116),
  [23] = {.count = 1, .reusable = true}, SHIFT(115),
  [25] = {.count = 1, .reusable = true}, SHIFT(114),
  [27] = {.count = 1, .reusable = true}, SHIFT(20),
  [29] = {.count = 1, .reusable = true}, SHIFT(19),
  [31] = {.count = 1, .reusable = true}, SHIFT(14),
  [33] = {.count = 1, .reusable = true}, SHIFT(16),
  [35] = {.count = 1, .reusable = true}, SHIFT(17),
  [37] = {.count = 1, .reusable = false}, SHIFT(98),
  [39] = {.count = 1, .reusable = true}, SHIFT(18),
  [41] = {.count = 1, .reusable = true}, SHIFT(33),
  [43] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 2),
  [45] = {.count = 1, .reusable = true}, SHIFT(13),
  [47] = {.count = 1, .reusable = true}, SHIFT(55),
  [49] = {.count = 1, .reusable = true}, SHIFT(40),
  [51] = {.count = 1, .reusable = true}, SHIFT(44),
  [53] = {.count = 1, .reusable = true}, SHIFT(49),
  [55] = {.count = 1, .reusable = true}, SHIFT(54),
  [57] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2),
  [59] = {.count = 2, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(106),
  [62] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(99),
  [65] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(2),
  [68] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(58),
  [71] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(35),
  [74] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(41),
  [77] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(51),
  [80] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(119),
  [83] = {.count = 2, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(117),
  [86] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(116),
  [89] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(115),
  [92] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(114),
  [95] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(20),
  [98] = {.count = 1, .reusable = true}, SHIFT(53),
  [100] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 1),
  [102] = {.count = 1, .reusable = true}, SHIFT(34),
  [104] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 1),
  [106] = {.count = 1, .reusable = true}, SHIFT(56),
  [108] = {.count = 1, .reusable = true}, SHIFT(23),
  [110] = {.count = 1, .reusable = true}, SHIFT(22),
  [112] = {.count = 1, .reusable = true}, SHIFT(50),
  [114] = {.count = 1, .reusable = true}, SHIFT(36),
  [116] = {.count = 1, .reusable = true}, SHIFT(57),
  [118] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 1),
  [120] = {.count = 1, .reusable = true}, SHIFT(68),
  [122] = {.count = 1, .reusable = true}, SHIFT(67),
  [124] = {.count = 1, .reusable = true}, SHIFT(65),
  [126] = {.count = 1, .reusable = true}, SHIFT(127),
  [128] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 1),
  [130] = {.count = 1, .reusable = true}, REDUCE(sym_backreference_escape, 3),
  [132] = {.count = 1, .reusable = false}, REDUCE(sym_backreference_escape, 3),
  [134] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 3),
  [136] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 3),
  [138] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 5, .production_id = 12),
  [140] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 5, .production_id = 12),
  [142] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_escape, 3),
  [144] = {.count = 1, .reusable = false}, REDUCE(sym_unicode_escape, 3),
  [146] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 3, .production_id = 4),
  [148] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 3, .production_id = 4),
  [150] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3),
  [152] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3),
  [154] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [156] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [158] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3, .production_id = 3),
  [160] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3, .production_id = 3),
  [162] = {.count = 1, .reusable = true}, REDUCE(sym_backreference_escape, 2),
  [164] = {.count = 1, .reusable = false}, REDUCE(sym_backreference_escape, 2),
  [166] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 5),
  [168] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 5),
  [170] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 5),
  [172] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 5),
  [174] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 5),
  [176] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 5),
  [178] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 2),
  [180] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 2),
  [182] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 3),
  [184] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 3),
  [186] = {.count = 1, .reusable = true}, REDUCE(sym_start_assertion, 1),
  [188] = {.count = 1, .reusable = false}, REDUCE(sym_start_assertion, 1),
  [190] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 3),
  [192] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 3),
  [194] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 4, .production_id = 3),
  [196] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 4, .production_id = 3),
  [198] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 2),
  [200] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 2),
  [202] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 4),
  [204] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 4),
  [206] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 4),
  [208] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 4),
  [210] = {.count = 1, .reusable = true}, REDUCE(sym_boundary_assertion, 1),
  [212] = {.count = 1, .reusable = false}, REDUCE(sym_boundary_assertion, 1),
  [214] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 7, .production_id = 12),
  [216] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 7, .production_id = 12),
  [218] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_escape, 2),
  [220] = {.count = 1, .reusable = false}, REDUCE(sym_unicode_escape, 2),
  [222] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [224] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [226] = {.count = 1, .reusable = true}, REDUCE(sym_hexadecimal_escape, 2),
  [228] = {.count = 1, .reusable = false}, REDUCE(sym_hexadecimal_escape, 2),
  [230] = {.count = 1, .reusable = true}, REDUCE(sym_control_letter_escape, 2),
  [232] = {.count = 1, .reusable = false}, REDUCE(sym_control_letter_escape, 2),
  [234] = {.count = 1, .reusable = true}, REDUCE(sym_identity_escape, 2),
  [236] = {.count = 1, .reusable = false}, REDUCE(sym_identity_escape, 2),
  [238] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 5, .production_id = 13),
  [240] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 5, .production_id = 13),
  [242] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 4),
  [244] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 4),
  [246] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [248] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [250] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 1),
  [252] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 1),
  [254] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 5),
  [256] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 5),
  [258] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 6, .production_id = 12),
  [260] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 6, .production_id = 12),
  [262] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 4),
  [264] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 4),
  [266] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 4),
  [268] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 4),
  [270] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 3),
  [272] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 3),
  [274] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 3),
  [276] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 3),
  [278] = {.count = 1, .reusable = false}, SHIFT(107),
  [280] = {.count = 1, .reusable = true}, SHIFT(62),
  [282] = {.count = 1, .reusable = true}, SHIFT(90),
  [284] = {.count = 1, .reusable = true}, SHIFT(38),
  [286] = {.count = 1, .reusable = true}, SHIFT(91),
  [288] = {.count = 1, .reusable = false}, SHIFT(79),
  [290] = {.count = 1, .reusable = true}, SHIFT(88),
  [292] = {.count = 1, .reusable = true}, SHIFT(139),
  [294] = {.count = 1, .reusable = false}, SHIFT(137),
  [296] = {.count = 1, .reusable = true}, SHIFT(142),
  [298] = {.count = 1, .reusable = true}, SHIFT(132),
  [300] = {.count = 1, .reusable = true}, SHIFT(133),
  [302] = {.count = 1, .reusable = true}, SHIFT(79),
  [304] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 3, .production_id = 5),
  [306] = {.count = 1, .reusable = true}, SHIFT(73),
  [308] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 3, .production_id = 5),
  [310] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5, .production_id = 14),
  [312] = {.count = 1, .reusable = true}, SHIFT(75),
  [314] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5, .production_id = 14),
  [316] = {.count = 1, .reusable = true}, SHIFT(26),
  [318] = {.count = 1, .reusable = true}, SHIFT(28),
  [320] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4, .production_id = 10),
  [322] = {.count = 1, .reusable = true}, SHIFT(69),
  [324] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4, .production_id = 10),
  [326] = {.count = 1, .reusable = true}, SHIFT(37),
  [328] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 1),
  [330] = {.count = 1, .reusable = true}, SHIFT(70),
  [332] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 1),
  [334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(107),
  [337] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(90),
  [340] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2),
  [342] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(91),
  [345] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(79),
  [348] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(88),
  [351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(139),
  [354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(137),
  [357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(142),
  [360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(132),
  [363] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(133),
  [366] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 1),
  [368] = {.count = 1, .reusable = true}, SHIFT(71),
  [370] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 1),
  [372] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 1),
  [374] = {.count = 1, .reusable = true}, SHIFT(72),
  [376] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 1),
  [378] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5, .production_id = 15),
  [380] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5, .production_id = 15),
  [382] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 2, .production_id = 2),
  [384] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 2, .production_id = 2),
  [386] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 2, .production_id = 2),
  [388] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 2, .production_id = 2),
  [390] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 2, .production_id = 2),
  [392] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 2, .production_id = 2),
  [394] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4, .production_id = 11),
  [396] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4, .production_id = 11),
  [398] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2),
  [400] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 6, .production_id = 16),
  [402] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 6, .production_id = 16),
  [404] = {.count = 1, .reusable = true}, SHIFT(94),
  [406] = {.count = 1, .reusable = true}, SHIFT(89),
  [408] = {.count = 1, .reusable = true}, SHIFT(92),
  [410] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 1),
  [412] = {.count = 1, .reusable = true}, SHIFT(93),
  [414] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1),
  [416] = {.count = 1, .reusable = true}, SHIFT(76),
  [418] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1),
  [420] = {.count = 1, .reusable = false}, REDUCE(sym_set_identity_escape, 2),
  [422] = {.count = 1, .reusable = true}, REDUCE(sym_set_identity_escape, 2),
  [424] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 7),
  [426] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 7),
  [428] = {.count = 1, .reusable = true}, SHIFT(78),
  [430] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [432] = {.count = 1, .reusable = true}, SHIFT(77),
  [434] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [436] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 8),
  [438] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 8),
  [440] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 9),
  [442] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 9),
  [444] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 6),
  [446] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 6),
  [448] = {.count = 1, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2),
  [450] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(95),
  [453] = {.count = 2, .reusable = false}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(131),
  [456] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(140),
  [459] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 2),
  [461] = {.count = 1, .reusable = true}, SHIFT(95),
  [463] = {.count = 1, .reusable = false}, SHIFT(131),
  [465] = {.count = 1, .reusable = true}, SHIFT(140),
  [467] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 1),
  [469] = {.count = 1, .reusable = true}, SHIFT(96),
  [471] = {.count = 1, .reusable = true}, SHIFT(97),
  [473] = {.count = 1, .reusable = true}, SHIFT(84),
  [475] = {.count = 1, .reusable = true}, SHIFT(141),
  [477] = {.count = 1, .reusable = true}, SHIFT(81),
  [479] = {.count = 1, .reusable = true}, SHIFT(85),
  [481] = {.count = 1, .reusable = true}, SHIFT(130),
  [483] = {.count = 1, .reusable = true}, SHIFT(63),
  [485] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 3),
  [487] = {.count = 1, .reusable = true}, SHIFT(29),
  [489] = {.count = 1, .reusable = true}, REDUCE(sym_escape_operator, 1),
  [491] = {.count = 1, .reusable = true}, SHIFT(104),
  [493] = {.count = 1, .reusable = true}, SHIFT(59),
  [495] = {.count = 1, .reusable = true}, SHIFT(25),
  [497] = {.count = 1, .reusable = true}, SHIFT(128),
  [499] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2),
  [501] = {.count = 1, .reusable = true}, SHIFT(24),
  [503] = {.count = 1, .reusable = true}, SHIFT(47),
  [505] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [507] = {.count = 1, .reusable = true}, SHIFT(46),
  [509] = {.count = 1, .reusable = true}, SHIFT(45),
  [511] = {.count = 1, .reusable = true}, SHIFT(111),
  [513] = {.count = 1, .reusable = true}, SHIFT(43),
  [515] = {.count = 1, .reusable = true}, SHIFT(42),
  [517] = {.count = 1, .reusable = true}, SHIFT(109),
  [519] = {.count = 1, .reusable = true}, SHIFT(52),
  [521] = {.count = 1, .reusable = true}, SHIFT(27),
  [523] = {.count = 1, .reusable = true}, SHIFT(21),
  [525] = {.count = 1, .reusable = true}, SHIFT(30),
  [527] = {.count = 1, .reusable = true}, SHIFT(15),
  [529] = {.count = 1, .reusable = true}, SHIFT(31),
  [531] = {.count = 1, .reusable = true}, SHIFT(32),
  [533] = {.count = 1, .reusable = true}, SHIFT(108),
  [535] = {.count = 1, .reusable = true}, SHIFT(134),
  [537] = {.count = 1, .reusable = true}, SHIFT(39),
  [539] = {.count = 1, .reusable = true}, SHIFT(60),
  [541] = {.count = 1, .reusable = true}, SHIFT(101),
  [543] = {.count = 1, .reusable = true}, SHIFT(87),
  [545] = {.count = 1, .reusable = true}, SHIFT(86),
  [547] = {.count = 1, .reusable = true}, SHIFT(48),
  [549] = {.count = 1, .reusable = true}, SHIFT(100),
  [551] = {.count = 1, .reusable = true}, SHIFT(83),
  [553] = {.count = 1, .reusable = true}, SHIFT(82),
  [555] = {.count = 1, .reusable = true}, SHIFT(80),
  [557] = {.count = 1, .reusable = true}, SHIFT(102),
  [559] = {.count = 1, .reusable = true}, SHIFT(135),
  [561] = {.count = 1, .reusable = true}, SHIFT(136),
  [563] = {.count = 1, .reusable = true}, SHIFT(138),
};

void *tree_sitter_regex_external_scanner_create(void);
void tree_sitter_regex_external_scanner_destroy(void *);
bool tree_sitter_regex_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_regex_external_scanner_serialize(void *, char *);
void tree_sitter_regex_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_regex(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_regex_external_scanner_create,
      tree_sitter_regex_external_scanner_destroy,
      tree_sitter_regex_external_scanner_scan,
      tree_sitter_regex_external_scanner_serialize,
      tree_sitter_regex_external_scanner_deserialize,
    },
  };
  return &language;
}
